{************************************************************}
{                   Delphi VCL Extensions                    }
{                                                            }
{                 Basic constants and types                  }
{                                                            }
{      Copyright (c) 2002-2010 SoftGold software company     }
{                                                            }
{************************************************************}
unit sgConsts;
{$INCLUDE SGDXF.INC}

interface

uses
  Windows, Classes, Registry, Graphics
{$IFDEF SGDEL_7}
{$IFDEF SG_USE_INDY}
  ,IdHTTP, IdAntiFreeze
{$ENDIF}
{$ENDIF}
{$IFDEF SGDEL_2009}
  , Character
{$ENDIF}
  ;

const
  //dxf/dwg colors
  clByLayer = $2FFFFFFF;
  clByBlock = $3FFFFFFF;
  clEmpty   = $5FFFFFFF;
  // Constants for CAD import (entities)
  DXF_SEC_TABLES	    = 0;
  DXF_SEC_BLOCKS	    = 1;
  DXF_SEC_ENTITIES  	= 2;
  DXF_SEC_LTYPE		    = 3;
  DXF_SEC_LAYERS	    = 4;

  DXF_UNKNOWN	       	= 0;
  DXF_TABLE		        = 1;
  DXF_BLOCK		        = 2;
  DXF_LTYPE	         	= 3;
  DXF_LAYER		        = 4;
  DXF_VERTEX		      = 5;
  DXF_LINE		        = 6;
  DXF_SOLID		        = 7;
  DXF_CIRCLE		      = 8;
  DXF_ARC		          = 9;
  DXF_POLYLINE     		= 10;
  DXF_LWPOLYLINE	    = 11;
  DXF_SPLINE		      = 12;
  DXF_INSERT		      = 13;
  DXF_DIMENSION		    = 14;
  DXF_TEXT		        = 15;
  DXF_MTEXT		        = 16;
  DXF_ATTDEF		      = 17;
  DXF_ELLIPSE		      = 18;
  DXF_POINT		        = 19;
  DXF_3DFACE	      	= 20;
  DXF_HATCH		        = 21;
  DXF_IMAGE_ENT       = 22;
  DXF_ATTRIB		      = 23;

  DXF_BEGIN_POLYLINE = 100;
  DXF_END_POLYLINE   = 101;
  DXF_BEGIN_INSERT   = 102;
  DXF_END_INSERT     = 103;
  DXF_BEGIN_VIEWPORT = 104;
  DXF_END_VIEWPORT   = 105;

  
  // Constants for reading CAD images
  Info_0 = 0;
  Text_1 = 1;
  Name_2 = 2;
  Text_3 = 3;
  Text_4 = 4;
  Text_5 = 5;
  LineTypeName_6 = 6;
  TextFont_7 = 7;
  LayerName_8 = 8;
  VarName_9 = 9;
  XFirst_10 = 10;
  XOther_11 = 11;
  XOther_12 = 12;
  XOther_13 = 13;
  XOther_14 = 14;
  XOther_15 = 15;
  XOther_16 = 16;
  XOther_17 = 17;
  XOther_18 = 18;
  XOther_110 = 110;
  XOther_111 = 111;
  XOther_112 = 112;
  YFirst_20 = 20;
  YOther_21 = 21;
  YOther_22 = 22;
  YOther_23 = 23;
  YOther_24 = 24;
  YOther_25 = 25;
  YOther_26 = 26;
  YOther_27 = 27;
  YOther_28 = 28;
  YOther_120 = 120;
  YOther_121 = 121;
  YOther_122 = 122;
  ZFirst_30 = 30;
  ZOther_31 = 31;
  ZOther_32 = 32;
  ZOther_33 = 33;
  ZOther_34 = 34;
  ZOther_35 = 35;
  ZOther_36 = 36;
  ZOther_37 = 37;
  ZOther_130 = 130;
  ZOther_131 = 131;
  ZOther_132 = 132;
  Elevation_38 = 38;
  TableOfEntity_39 = 39;
  Float_40 = 40;
  Float_41 = 41;
  Float_42 = 42;
  Float_43 = 43;
  Float_44 = 44;
  Float_45 = 45;
  Float_46 = 46;
  Float_47 = 47;
  Float_48 = 48;
  FloatRepeated_49 = 49;
  Float_140 = 140;
  Float_141 = 141;
  Float_142 = 142;
  Float_143 = 143;
  Float_144 = 144;
  Float_145 = 145;
  Float_146 = 146;
  Float_147 = 147;
  Float_148 = 148;
  Float_149 = 149;
  Float_211 = 211;
  Float_221 = 221;
  Float_231 = 231;
  Float_239 = 239;
  Float_1010 = 1010;
  Float_1020 = 1020;
  Float_1030 = 1030;
  Float_1040 = 1040;
  Float_1041 = 1041;
  Float_1042 = 1042;
  Angle_50 = 50;
  Angle_51 = 51;
  Angle_52 = 52;
  Angle_53 = 53;
  Angle_54 = 54;
  Angle_55 = 55;
  Angle_56 = 56;
  Angle_57 = 57;
  Angle_58 = 58;
  Visible_60 = 60;
  ColorNumber_62 = 62;
  UCSVP_65 = 65;
  EntitysBegin_66 = 66;
  PaperSpace_67 = 67;
  Integer_68 = 68;
  Integer_69 = 69;
  Integer_70 = 70;
  Integer_71 = 71;
  Integer_72 = 72;
  Integer_73 = 73;
  Integer_74 = 74;
  Integer_75 = 75;
  Integer_76 = 76;
  Integer_77 = 77;
  Integer_78 = 78;
  Integer_79 = 79;
  Integer_90 = 90;
  Integer_91 = 91;
  Integer_92 = 92;
  Integer_93 = 93;
  Integer_97 = 97;
  Integer_170 = 170;
  Integer_171 = 171;
  Integer_172 = 172;
  Integer_173 = 173;
  Integer_174 = 174;
  Integer_175 = 175;  
  Integer_176 = 176;
  Integer_177 = 177;
  Integer_178 = 178;
  Integer_271 = 271;  
  Integer_290 = 290;
  Integer_1070  = 1070;
  Integer_1071  = 1071;  
  Word_280      = 280;
  Word_281      = 281;
  Word_282      = 282;
  Word_283      = 283;
  Word_284      = 284;
  Word_285      = 285;
  Word_286      = 286;
  Word_287      = 287;
  Word_288      = 288;
  Word_289      = 289;
  Extrusion_210 = 210;
  Extrusion_220 = 220;
  Extrusion_230 = 230;
  String_100 = 100;
  String_310 = 310;
  String_330 = 330;
  String_331 = 331;
  String_340 = 340;
  String_341 = 341;
  String_342 = 342;  
  Integer_370 = 370;
  Integer_400 = 400;
  String_410 = 410;
  String_411 = 411;
  String_412 = 412;
  String_413 = 413;
  String_414 = 414;
  String_415 = 415;
  String_430 = 430;
  String_431 = 431;
  String_432 = 432;
  String_433 = 433;
  String_434 = 434;
  String_435 = 435;
  String_439 = 439;  
  String_1000 = 1000;
  String_1001 = 1001;
  String_1002 = 1002;
  String_1003 = 1003;
  String_1005 = 1005;

  UserDigit = 23111;

  cnstGUID_Change = '{3322123D-F8FA-4170-9040-A25C271B1887}';

  sgDimensionArrowTypeNames: array [0..20] of string = ('_CLOSEDFILLED',
    '_CLOSEDBLANK', '_CLOSED', '_DOT', '_ARCHTICK', '_OBLIQUE', '_OPEN',
    '_ORIGIN', '_ORIGIN2', '_OPEN90', '_OPEN30', '_DOTSMALL', '_DOTBLANK',
    '_SMALL', '_BOXBLANK', '_BOXFILLED', '_DATUMBLANK', '_DATUMFILLED',
    '_INTEGRAL', '_USERARROW', '_NONE');

  cnstGradientName: array [0..8] of string = ('CURVED', 'CYLINDER', 'HEMISPHERICAL', 'LINEAR',
    'SPHERICAL', 'INVCURVED', 'INVCYLINDER', 'INVHEMISPHERICAL', 'INVSPHERICAL');

  sStringBreak = #1;
  sByBlock = 'BYBLOCK';
  sByLayer = 'BYLAYER';
  sContinuous = 'CONTINUOUS';
  sModel  = 'Model';
  sLayout = 'Layout';
  sACADXDataAppName = 'ACAD';
  sActiveVPort = '*ACTIVE';
  sModelSpace  = '*MODEL_SPACE';
  sPaperSpace  = '*PAPER_SPACE';

  sLayerDefPoints = 'DEFPOINTS';
  sStandardName = 'STANDARD';
  sDefaultStyleName = 'GOST';// name is equal to a fontname
  cnstBadHandle = 0;
  cnstDefColor: Integer = clWhite;
  cnstEnumValuesDelimiter = '|';

  cnstSymbolAngle = '< ';
  cnstSymbolDegree = '';

  cnstMaxLongWord = High(LongWord);

{$IFDEF SG_BTI}
  sGeron: string = 'Geron';
  sSegmentAH: string = 'SegmentAH';
  sSegmentAL: string = 'SegmentAL';
  sRadin: string = 'Radian';
  sSin: string = 'Sin';
  sSqr: string = 'Sqr';
  sSqrt: string = 'Sqrt';
  cnstParamType: array [0..3] of string = (cnstEnumValuesDelimiter + 'AREA', cnstEnumValuesDelimiter + 'NUMBER',
    cnstEnumValuesDelimiter + 'PERIMETER', cnstEnumValuesDelimiter + 'NUMBEROWNER');
{$ENDIF}

  // Names of a DXF-entities
  sPolyline = 'Polyline';
  sCircle   = 'Circle';
  sEllipse  = 'Ellipse';
  sHatchEntity   = 'HATCH';
  sPatternSOLID  = 'SOLID';
  sPatternANSI31 = 'ANSI31';// FDiagonal, BDiagonal
  sPatternANSI37 = 'ANSI37';// DiagCross
  sPatternNET    = 'NET';   // Cross
  sPatternLINE   = 'LINE';  // Horizintal, Vertical

  sRedlineLayerName = 'Redline_layer';
  sTempFileName = '~cs_temp_file_.';

  // Default numbers of parts for parsing circle and spline
  iDefaultNumberOfCircleParts = 47;//13;
  iDefaultNumberOfSplineParts = 24;
  iCurrentNumberOfCircleParts: Integer = iDefaultNumberOfCircleParts;
  iCurrentNumberOfSplineParts: Integer = iDefaultNumberOfSplineParts;
  iMinNumberOfCircleParts = 4;

  //Maximum count of the lines in a dotted polyline or curve
  //(if count of lines more then iMaxNumDottedLines we draws solid-polyline)
  iMaxNumDottedLines = 1000;

  //It is necessary for comparison floating-point numbers
  fAccuracy = 0.000001;
  fDoubleResolution = 1E-09;//1E-15;
  // bad value for all singles
  BadSingValue: Single = -24444444;

  // Windows text height factor
  fWinTextHeightFactor: Extended = 1.6000000000;

  // Windows text Y-offset factor by height
  fWinTextYOffsetFactor: Extended = 0.2700000000;

  // Pi / 180
  fPiDividedBy180: Extended = 0.017453292519943295769236907684886;
  // 180 / Pi
  f180DividedByPi: Extended = 57.295779513082320876798154814105;
  cIPointsCnt = 8;

  //Lineweight settings
  bLineWeightOn: Boolean = True;
  fLineWeightByLayer: Double = -1.0;
  fLineWeightByBlock: Double = -2.0;
  fLineWeightDefault: Double = -3.0;
  fLineWeightFactor: Single = 1.0;
  sLineWeightFactor = 'LineWeightDispFactor';

  sCorruptedDWGFileHeader: string = 'DWG file header is corrupted';
  sEncryptedByPassword: string = 'Encrypted by password';
  sUnsupportedOldDWGVer: string = 'Unsupported old DWG version ID:';
  sUnsupportedNewDWGVer: string = 'Unsupported new DWG version ID:';
  sRSBlockSizeError: string = 'Block size error';
  sRSMaxErrors: string = 'The number of errors cannot be more than %d';
  sRSDecoderError: string = 'RS decoder error. DWG file is corrupted!';
  sDWG2007HeaderError: string = 'Error in DWG 2007 header';
  sDWGCompilerError: string = 'Unsupported compiler version for DWG %s';
  sDecompressDWGError: string = 'Unexpected error has occurred while DWG file decompressing';

  sUNKNOW: string = 'UNKNOW';
  sEntNamesEx: array [-1..14] of string = ('UNKNOW', 'DIMCONSTRUCTION',
    'CONSTRUCTION', 'COMPLEX', 'ELEMENT','COMPLEX BROAD', 'COMPLEX LINEAR',
    'ELEMENT BROAD','ELEMENT LINEAR', 'ELEMENT CARVED', 'AREA OBJECTS', 'AREAS UNION',
    'LABEL', 'DIMLABEL', 'BLOCK PATTERN', 'ELEMENT MODIFIER');
  cnstROOM: string = 'TEMPLATES';
  cnstROOMAREA: string = 'AREAS OF FILE';
  cnstROOMFILE: string = 'TEMPLATES OF FILE';
  cnstDefaultTTFFont = {$IFDEF SG_BTI_INTERFACE}'Gost'{$ELSE}'Arial'{$ENDIF};


var
  CADPreview: Boolean = False;
  bUseSHXFonts: Boolean = False;
  bUseGDIPlusForRastImgRotate: Boolean = True;
  //bUseTTFFonts: Boolean = False;
  bSearchSHXPaths: Boolean = True;
  sDefaultTTFFont: string = cnstDefaultTTFFont;
  sDefaultSHXPath: string = '';
  sDefaultSHXFont: string = 'simplex.shx';//'txt.shx';
  sSHXSearchPaths: string = '';
  sgClientRect: TRect = (Left:MaxInt; Top:MaxInt; Right:-MaxInt; Bottom:-MaxInt);
  sgClientRectForSnap: TRect;
  sgVisibleArea: TPoint; //!Snap!
  KeepOriginal: Boolean = False; // save/load/assign original stream

const
  sInternalDimension = 'sgDim';

  SMessageAnalysing: string = 'Performing file analysing';
  SMessageCleaning: string = 'Performing file cleaning';
  sLoadFile: string = 'Loading file...';
  sLoadEntities: string = 'Loading entities...';

  // AutoCAD 8-bit colors
  arrDXFtoRGBColors: array [0..255] of Cardinal = (
    $000000, $0000FF, $00FFFF, $00FF00, $FFFF00, $FF0000, $FF00FF, $FFFFFF,
    $808080, $C0C0C0, $0000FF, $7F7FFF, $0000CC, $6666CC, $000099, $4C4C99,
    $00007F, $3F3F7F, $00004C, $26264C, $003FFF, $7F9FFF, $0033CC, $667FCC,
    $002699, $4C5F99, $001F7F, $3F4F7F, $00134C, $262F4C, $007FFF, $7FBFFF,
    $0066CC, $6699CC, $004C99, $4C7299, $003F7F, $3F5F7F, $00264C, $26394C,
    $00BFFF, $7FDFFF, $0099CC, $66B2CC, $007299, $4C8599, $005F7F, $3F6F7F,
    $00394C, $26424C, $00FFFF, $7FFFFF, $00CCCC, $66CCCC, $009999, $4C9999,
    $007F7F, $3F7F7F, $004C4C, $264C4C, $00FFBF, $7FFFDF, $00CC99, $66CCB2,
    $009972, $4C9985, $007F5F, $3F7F6F, $004C39, $264C42, $00FF7F, $7FFFBF,
    $00CC66, $66CC99, $00994C, $4C9972, $007F3F, $3F7F5F, $004C26, $264C39,
    $00FF3F, $7FFF9F, $00CC33, $66CC7F, $009926, $4C995F, $007F1F, $3F7F4F,
    $004C13, $264C2F, $00FF00, $7FFF7F, $00CC00, $66CC66, $009900, $4C994C,
    $007F00, $3F7F3F, $004C00, $264C26, $3FFF00, $9FFF7F, $33CC00, $7FCC66,
    $269900, $5F994C, $1F7F00, $4F7F3F, $134C00, $2F4C26, $7FFF00, $BFFF7F,
    $66CC00, $99CC66, $4C9900, $72994C, $3F7F00, $5F7F3F, $264C00, $394C26,
    $BFFF00, $DFFF7F, $99CC00, $B2CC66, $729900, $85994C, $5F7F00, $6F7F3F,
    $394C00, $424C26, $FFFF00, $FFFF7F, $CCCC00, $CCCC66, $999900, $99994C,
    $7F7F00, $7F7F3F, $4C4C00, $4C4C26, $FFBF00, $FFDF7F, $CC9900, $CCB266,
    $997200, $99854C, $7F5F00, $7F6F3F, $4C3900, $4C4226, $FF7F00, $FFBF7F,
    $CC6600, $CC9966, $994C00, $99724C, $7F3F00, $7F5F3F, $4C2600, $4C3926,
    $FF3F00, $FF9F7F, $CC3300, $CC7F66, $992600, $995F4C, $7F1F00, $7F4F3F,
    $4C1300, $4C2F26, $FF0000, $FF7F7F, $CC0000, $CC6666, $990000, $994C4C,
    $7F0000, $7F3F3F, $4C0000, $4C2626, $FF003F, $FF7F9F, $CC0033, $CC667F,
    $990026, $994C5F, $7F001F, $7F3F4F, $4C0013, $4C262F, $FF007F, $FF7FBF,
    $CC0066, $CC6699, $99004C, $994C72, $7F003F, $7F3F5F, $4C0026, $4C2639,
    $FF00BF, $FF7FDF, $CC0099, $CC66B2, $990072, $994C85, $7F005F, $7F3F6F,
    $4C0039, $4C2642, $FF00FF, $FF7FFF, $CC00CC, $CC66CC, $990099, $994C99,
    $7F007F, $7F3F7F, $4C004C, $4C264C, $BF00FF, $DF7FFF, $9900CC, $B266CC, 
    $720099, $854C99, $5F007F, $6F3F7F, $39004C, $42264C, $7F00FF, $BF7FFF,
    $6600CC, $9966CC, $4C0099, $724C99, $3F007F, $5F3F7F, $26004C, $39264C,
    $3F00FF, $9F7FFF, $3300CC, $7F66CC, $260099, $5F4C99, $1F007F, $4F3F7F,
    $13004C, $2F264C, $333333, $5B5B5B, $848484, $ADADAD, $D6D6D6, $FFFFFF);

  sgDXFLineWeights: array [0..23] of Integer = (0, 5, 9, 13, 15, 18, 20, 25, 30, 35,
    40, 50, 53, 60, 70, 80, 90, 100, 106, 120, 140, 158, 200, 211);
(*  //For future versions
  bUseFastDraw: Boolean = True;
*)      
    
// Types
type
  PsgFloat = ^TsgFloat;
  TsgFloat = Double;
  sgRawByteString = {$IFDEF SGDEL_2009} RawByteString {$ELSE} AnsiString {$ENDIF} ;
  sgUnicodeStr = {$IFDEF SGDEL_2009} string {$ELSE} WideString {$ENDIF} ;
  sgUnicodeChar = {$IFDEF SGDEL_2009} Char {$ELSE} WideChar {$ENDIF} ;

  TsgInt64 = record
    Lo: Integer;
    Hi: Integer;
  end;

{$IFNDEF SGDEL_7}
  UInt64 = Int64;
{$ENDIF}

{$IFDEF SGDEL_2006}
  TsgUInt64 = record
  private
    FHi: Cardinal;
    FLo: Cardinal;
    function GetLo: Cardinal;
    procedure SetAll(const Value: Int64); inline;
    procedure SetHi(const Value: Cardinal); inline;
    procedure SetLo(const Value: Cardinal); inline;
    function GetHi: Cardinal; inline;
    function GetAll: Int64; inline;
  public
    property Lo: Cardinal read GetLo write SetLo;
    property Hi: Cardinal read GetHi write SetHi;
    property All: Int64 read GetAll write SetAll;
    class operator Implicit(I: Integer): TsgUInt64; inline;
    class operator Implicit(I: Int64): TsgUInt64; inline;
    class operator Implicit(const A: TsgUInt64): Integer; inline;
    class operator Implicit(const A: TsgUInt64): Int64; inline;
    class operator Negative(const A: TsgUInt64): TsgUInt64;
    class operator Equal(const A,B: TsgUInt64): Boolean;
    class operator NotEqual(const A,B: TsgUInt64): Boolean;
    class operator GreaterThan(const A,B: TsgUInt64): Boolean;
    class operator GreaterThanOrEqual(const A,B: TsgUInt64): Boolean;
    class operator LessThan(const A,B: TsgUInt64): Boolean;
    class operator LessThanOrEqual(const A,B: TsgUInt64): Boolean;
    class operator LeftShift(const A: TsgUInt64; B: Integer): TsgUInt64;
    class operator RightShift(const A: TsgUInt64; B: Integer): TsgUInt64;
    class operator Add(const A,B: TsgUInt64): TsgUInt64;
    class operator Subtract(const A,B: TsgUInt64): TsgUInt64;
    class operator BitwiseOr(const A,B: TsgUInt64): TsgUInt64;
  end;
{$ENDIF}

  PFPoint = ^TFPoint;
  TFPoint = record
  case Integer of
    0: (X, Y, Z: TsgFloat);
    1: (V: array[0..2] of TsgFloat);
  end;

  PF2DPoint = ^TF2DPoint;
  TF2DPoint = packed record
  case Integer of
    0: (X, Y: TsgFloat);
    1: (V: array[0..1] of TsgFloat);
  end;

  PF2DLine = ^TF2DLine;
  TF2DLine = packed record
    Point1: TF2DPoint;
    Point2: TF2DPoint;
  end;

  TsgCurveProperty  = (lpVisible, lpJoin, lpArc);
  TsgCurveProperties = set of TsgCurveProperty;

  PsgArcR = ^TsgArcR;
  TsgArcR = record
    Center: TFPoint;
    Radius: Double;
    AngleS: Double;
    AngleE: Double;
  end;

  PF2DCurveEx = ^TF2DCurveEx;
  TF2DCurveEx = packed record
    Flags: TsgCurveProperties;
    case Integer of
      0: (Line: TF2DLine);
      1: (Arc: TsgArcR);
  end;

  PdxfPoint = ^TdxfPoint;
  TdxfPoint = record
    X,Y,Z: Single;
  end;

  PsgLine = ^TsgLine;
  TsgLine = packed record
    Point1: TFPoint;
    Point2: TFPoint;
  end;

  PFRect = ^TFRect;
  TFRect = record
  case Integer of
    0: (Left, Top, Z1, Right, Bottom, Z2: TsgFloat);
    1: (TopLeft, BottomRight: TFPoint);
  end;

  PF2DRect = ^TF2DRect;
  TF2DRect = packed record
  case Integer of
    0: (Left, Top, Right, Bottom: TsgFloat);
    1: (TopLeft, BottomRight: TF2DPoint);
  end;

  PsgColor = ^TsgColor;
  TsgColor = packed record
  case Integer of
    0: (R, G, B, A: Byte);
    1: (V: array [0..3] of Byte);
    2: (Color: DWORD);
  end;

  PsgViewBox = ^TsgViewBox;
  TsgViewBox = packed record
  Mode: Byte;
  case Integer of
    0: (X, Y, Width, Height: TsgFloat);
    1: (Point, Size: TF2DPoint);
  end;

  PsgFontParams = ^TsgFontParams;
  TsgFontParams = packed record
    Above: Double;
    Below: Double;
    Width: Double;
    Height: Double;
    Left: Double;
    Bottom: Double;
    Right: Double;
    Top: Double;
    After: Double;
    DY: Double;
    DX: Double;
  end;

  PsgImageProperties = ^TsgImageProperties;
  TsgImageProperties = packed record
    DPI: TF2DPoint;
    Size: TPoint;
  end;

  TsgParamType = (ptUndefined, ptObject, ptList, ptPoint, ptDistance, ptAngle);
  TsgParamTypes = set of TsgParamType;

  PsgParamData = ^TsgParamData;
  TsgParamData = packed record
    PType: TsgParamType;
    case TsgParamType of
      ptUndefined: (DataUnd: Pointer);
      ptObject:    (DataObj: TObject);
      ptList:      (DataLst: TList);
      ptPoint:     (DataPnt: TFPoint);
      ptDistance:  (DataDst: Double);
      ptAngle:     (DataAng: Double);
  end;  

{$IFDEF SG_BTI}
  TsgFigureType = (ftFigure, ftQuadrangle, ftTrapezium, ftParallelogram, ftRect, ftSquare, ftRhomb,
    ftSegmentByChordAndLength, ftSegmentByChordAndHeight, ftTriangle, ftTriangleRightAngled,
    ftTriangleByHippuran, ftCircleByLength, ftCircleByRadius, ftSectorByAngleAndRadius, ftContour);

  // Basic entity data
  PsgData = ^TsgData;
  TsgData = packed record
    BlockPattern: TObject;
    xByteArray: array [0..5] of Byte;
    xDoubleArray: array[0..10] of Double;
    xIntArray: array[0..1] of Integer;
    { Fields below may be added in future versions }
  end;

  // Extended entity data
  PsgExtendedData = ^TsgExtendedData;
  TsgExtendedData = packed record
    Data: TsgData;
    Handle: Pointer;
    Refs0: Pointer;
    Refs1: Pointer;
    Refs2: Pointer;
    Refs3: Pointer;
    Attribs: Pointer;
  end;
{$ENDIF}

  // Extended CAD data
  PcadExtendedData = ^TcadExtendedData;
  TcadExtendedData = packed record
    Param1: Pointer;// 4 byte field
    { Fields below may be added in future versions }
  end;

  TParseUnicodeMode = (puU, puM, puDP);
  TParseUnicodeModes = set of TParseUnicodeMode;

  TCmdSymReplaceProc = function(const AText: sgUnicodeStr): sgUnicodeStr;
  TsgObjProcTranslate = function(const AKey: string): string of object;

  PcadData = ^TcadData;
  TcadData = packed record
    Tag: Word;       // classindex, DXF_LINE, DXF_SOLID etc.
    Count: Word;     // number of child entities
    TickCount: Word;
    Flags: Byte;     // Flags byte
		     // for polylines: low bit <> 0 - is closed
		     // for layers: low bit <> 0 - is invisible
         // for text: low bit = 0 - is SHX - else - TTF
    Style: Byte;     // Style (pen, brush...) - for future versions
    Dimension: Integer;
    DashDots: PFPoint;
    DashDotsCount: Integer;
    Color: Integer;  // Color of entity
    Ticks: Pointer;
    Thickness: TsgFloat;// for future versions
    Rotation: TsgFloat; // Text or block rotation angle
    Layer: PChar;  // Layer name (only one layer for element)
    Text:  PChar;  // Pointer to text string
    FontName: PChar;
    Handle: THandle;
    Undefined1: Integer;
    Undefined2: TsgFloat;// Double
    Undefined3: TsgFloat;// Double
    CADExtendedData: PcadExtendedData;
    Point: TFPoint;   // Coordinates of the first point
    Point1: TFPoint;  // Coordinates of the second point
    Point2: TFPoint;  // Coordinates of the third point
    Point3: TFPoint;  // Coordinates of the fourth point
    case Integer of
    0: (Radius, StartAngle, EndAngle, Ratio: TsgFloat; EntityType: Byte); // for arcs (NOT in DXFEnum)
    1: (Block: THandle; Scale: TFPoint); // for Inserts (NOT in DXFEnum)
    2: (FHeight, FScale, RWidth, RHeight: TsgFloat; HAlign, VAlign: Byte); // for Text
    3: (Points: PFPoint);                // for polylines (in DXFEnum)
  end;

  PdxfData = ^TdxfData;
  TdxfData = packed record
    Tag: Word;       // classindex, DXF_LINE, DXF_SOLID etc.
    Count: Word;     // number of child entities
    TickCount: Word;
    Flags: Byte;     // Flags byte
		     // for polylines: low bit <> 0 - is closed
		     // for layers: low bit <> 0 - is invisible
    Style: Byte;     // Style (pen, brush...) - for future versions
    Dimension: Integer;
    DashDots: PdxfPoint;
    DashDotsCount: Integer;
    Color: Integer;  // Color of entity
    Ticks: Pointer;
    Thickness: Single;// for future versions
    Rotation: Single; // Text or block rotation angle
    Layer: PChar;  // Layer name (only one layer for element)
    Text:  PChar;  // Pointer to text string
    FontName: PChar;
    Handle: THandle;
    CADExtendedData: PcadExtendedData;
    Point: TdxfPoint;   // Coordinates of the first point
    Point1: TdxfPoint;  // Coordinates of the second point
    Point2: TdxfPoint;  // Coordinates of the third point
    Point3: TdxfPoint;  // Coordinates of the fourth point
    case Integer of
    0: (Radius, StartAngle, EndAngle, Ratio: Single; EntityType: Byte); // for arcs (NOT in DXFEnum)
    1: (Block: THandle; Scale: TdxfPoint); // for Inserts (NOT in DXFEnum)
    2: (FHeight, FScale, RWidth, RHeight: Single; HAlign, VAlign: Byte); // for Text
    3: (Points: PdxfPoint);                // for polylines (in DXFEnum)
  end;

  // Axes in 3-Dimensional cartesian coordinates
  TsgAxes = (axisX, axisY, axisZ);                

  TsgActivePoint = (apLeftTop, apLeftBottom, apCenter, apRightTop, apRightBottom);
  TsgAxisType = (atCenter, atLeft, atRight);  


  // DWG, DXF distance units mode
  TsgDistUnitsMode = (umDrawing, umUser, umAltUser);

  // DWG format version
  TsgDWGVersion = (acR09, acR10, acR11, acR12, acR13, acR14, acR2000, acR2004,
    acR2007, acR2010);

  // Numbers are necessary for compatibility with a TBrushStyle
  TsgHatchStyle = (hsSolid, hsPatternData, hsHorizontal, hsVertical, hsFDiagonal,
                  hsBDiagonal, hsCross, hsDiagCross);

  TsgImportMode = (imView, imImport);

  // Style of the CAD-drawing space
  TsgCADSpace = (cs2D, cs3D, csUndefined);

  // CAD drawing border type
  TsgBorderType = (btGlobal, btRatio);

  // CAD drawing border size
  TsgBorderSize = Double;

  TsgGradientType = (gtNone, gtCurved, gtCylinder, gtHemiSpherical, gtLinear,
    gtSpherical, gtInvCurved, gtInvCylinder, gtInvHemiSpherical, gtInvSpherical, gtOther);  

  PFMatrix = ^TFMatrix;
  TFMatrix = record
  case Integer of
    0: (V1, V2, V3, V4: array[0 .. 2] of TsgFloat);
    1: (M: array[0 .. 3, 0 .. 2] of TsgFloat);
    2: (EX, EY, EZ, E0: TFPoint);
  end;

  // Modes of 3D objects intersection
  TIntersectionMode = (imNone, imPoint, imLine, imPlane);

  // Object snap modes
  TObjectSnapMode = (osInsert, osEndPt, osCenter, osNode, osMiddle, osNormal,
    osNearest, osIntersection, osExtension, osDisabled, osGrid, osOrtho, osPolar, osAngle);

  // Object snap state
  TObjectSnapState = set of TObjectSnapMode;

  // The entities to be drawn
  TsgCADEnities = (ceEntity, cePoint, ceLine, ceSolid, ceTrace, ceCircle, ceArc,
     ceEllipse, cePolyline, ceLWPolyline, ceSpline, ceHelix, ceLeader, ceInsert, ceDimension,
     ceTolerance, ceMText, ceShape, ceText, ceAttdef, ceAttrib, ce3dFace, ceImageEnt, ceViewport,
     ceRegion, ceBody, ce3DSolid, cePattern, ceGradient, ceOle2Frame, cePolyPolygon,
     ceGradientPolygon, ceCurvePolygon, ceHatch, ceACADTable, ceFlatPoly, ceFlatHatch,
     ceXRef, ceProxy, cePath, ceWipeOut, ceMLine {$IFDEF SG_BTI},cePolyPolyline2D{$ENDIF});
  {$IFNDEF SGDEL_6}
  PCardinal = ^Cardinal;
  {$ENDIF}
  TsgCADEntityType = (etNone, etCustomVertex, etLine, etPolyLine, etLWPolyLine, etRect,
    etCircle, etEllipse, etMText, etLeader, etPath, etInsert, etBlock,
    etArc, etMulti, etDimAligned, etHatch, etText, etSolid, etSpline, etViewPort,
    etDimension, etSquare, etPoint, etPolyPolygon, etClipInsert, etACADTable, etTrace,
    etTolerance, etShape, etAttdef, etMLine, etWipeOut, etImageEnt, etHelix, etOle2Frame, 
    etCloud
{$IFDEF SG_BTI}
    ,etConstruction, etDimConstruction, etComplex, etElement, etComplexBroad,
    etComplexLinear, etElementBroad, etElementLinear, etElementCarved, etElementModifier,
    etArea, etComplexArea
{$ENDIF}
    ,etContainer);
    
  TsgCADEntityTypes = set of TsgCADEntityType;

  TsgCachingRasterMode = (crmNone, crmCache, crmDoubleCache);

  TsgPointClassify = (pcLEFT, pcRIGHT, pcBEYOND, pcBEHIND, pcBETWEEN, pcORIGIN,
    pcDESTINATION, psUNDEFINED);

  TsgPopMenuType = (pmtNone, pmtEnter, pmtCancel, pmtClose, pmtActPtMenu,
    pmtActPtLeftTop, pmtActPtLeftBottom, pmtActPtCenter, pmtActPtRightTop, pmtActPtRightBottom,
    pmtAreaMenu, pmtCreateAreaBySelect, pmtCreateAreaByPolyline,
    pmtCopy, pmtPaste, pmtPasteAsBlock, pmtCut, pmtDelete, pmtSelectAll, pmtUndo, pmtRedo, pmtZoomIn,
    pmtZoomOut, pmtFitToSize, pmtCreateCopy, pmtOffset, pmtDoubleOffset, pmtMove, pmtMirror, pmtRotate, pmtScale,
    pmtFindText, pmtProperties ,pmtOptions, pmtEditAttrib, pmtMatchSettings, pmtSendToBack, pmtBringToFront,
    pmtDrawArcs, pmtDrawLines, pmtAxisType, pmtAxisLeft, pmtAxisCenter, pmtAxisRight, pmtAreaProp,
    pmtClockOrCounterClockWise, pmtCW90, pmtCCW90, pmtRotate180, pmtCreateAreaByPoint, pmtFullScreen,
    pmtExitTemplateEditor, pmtExitBlockEditor, pmtBlockEditor);
  TsgPopMenuTypes = set of TsgPopMenuType;

  TsgFormResult = (frCancel, frOk, frAdd, frClose, frDelete, frSelectEntities,
    frSelectPoint, frSelectLength, frSelectAngle, frYes, frNo, frIgnore, frDeleteAll);

  PRectCoords = ^TsgRectCoords;
  TsgRectCoords = record
    Number: string;
    Point: TFPoint;
  end;

  TsgSizesOrientation = (soAuto, soHorizontal, soVertical);
  TsgSizeGenerate = record
    TypeText: TsgSizesOrientation;
    ColorText: TColor;
    TextHeight: Double;
    Offset: Double;
    Precision: Integer;
    Scale: Double;
  end;

  TsgInsUnits = (iuUnitless, iuInches, iuFeet, iuMiles, iuMillimeters, iuCentimeters,
    iuMeters, iuKilometers, iuMicroinches, iuMils, iuYards, iuAngstroms, iuNanometers,
    iuMicrons, iuDecimeters, iuDecameters, iuHectometers, iuGigameters, iuAstronomical,
    iuLightyears, iuParsecs);

  TsgUnitsInsertTempl = (uitMilimetr, uitMetr, uitUndefined);

  PSnapData = ^TSnapData;
  TSnapData = record
    IsSnapPoint: Boolean;
    Entity: TObject;
    SnapMode: TObjectSnapState;
    CADPoint: TFPoint;
    CADPointInUCS: TFPoint;
  end;
  PPSnapData = ^PSnapData;

  TsgHTTPProxyInfo = record
    ProxyHost: string;
    ProxyPort: Integer;
    ProxyNeedPass: Boolean;
    ProxyUser: string;
    ProxyPass: string;
  end;

  PsgDimStyle = ^TsgDimStyle;
  TsgDimStyle = record
    Alt: Boolean;
    AltF: Double;
    APost: string;
    Asz: Double;
    Blk: Byte;
    Blk1: Byte;
    Blk2: Byte;
    LrBlk: Byte;
    Cen: Double;
    ClrD: TColor;
    ClrE: TColor;
    ClrT: TColor;
    SD1: Boolean;
    SD2: Boolean;
    SE1: Boolean;
    SE2: Boolean;
    Dec: Integer;
    Exe: Double;
    Exo: Double;
    Gap: Double;
    LFac: Double;
    LwD: Double;
    LwE: Double;
    Post: string;
    Scale: Double;
    Tad: Integer;
    Tih: Boolean;
    Tix: Integer;
    Toh: Boolean;
    Txt: Double;
  end;

  PsgHeadVarStruct = ^TsgHeadVarStruct;
  TsgHeadVarStruct = record
    CEColor: TColor;
    CLayer: string;
    CELType: string;
    CELTScale: Double;
    CELWeight: Double;
    CodePage: Integer;
    DimStyle: string;
    DimTextStyle: string;
    DimProps: TsgDimStyle;
    ExtMim: TFPoint;
    ExtMax: TFPoint;
    TextStyle: string;
    FilletRadius: Double;
    InsUnits: Integer;
    LScale: Double;
    Measurement: Boolean;
    PointDisplayMode: Integer;
    PointDisplaySize: Double;
    TextSize: Double;
    TileMode: Integer;
    UCSORG: TFPoint;
    UCSXDir: TFPoint;
    UCSYDir: TFPoint;
    Version: Byte;
  end;

  PsgLittleHeadVarStruct = ^TsgLittleHeadVarStruct;
  TsgLittleHeadVarStruct = packed record
    InitFlags: LongWord;
    DimDec: Integer;
    DimLFac: Double;
    DimTxt: Double;
    DimTextAlign: Byte;
    DimClrT: TColor;
    DimGap: Double;
  end;

  TsgGroupType = (gtCAD, gtBTI, gtSVG);

  TsvgEntity = (svgUndefined, svgContainer, svgGroup, svgGroupDim, svgEntity, svgPoint, svgCircle,
    svgEllipse, svgLine, svgLink, svgPolyline, svgRect, svgPath, svgText, svgTextPath,
    svgUse, svgImage);

  TbtiEntity = (btiUndefined, btiConstruction, btiDimConstruction, btiComplex, btiComplexBroad,
    btiComplexLinear, btiElement, btiElementBroad, btiElementLinear, btiElementCarved,
    btiElementModifier, btiArea, btiComplexArea, btiLabel, btiDimLabel, btiBlockPattern);

  TsgEntityTypeEx = record
    case Byte of
      0: (Val: Byte);
      1: (CAD: TsgCADEnities);
      2: (BTI: TbtiEntity);
      3: (SVG: TsvgEntity);
  end;

  TsgEntClass = record
    case Byte of
      0: (ID: Word);
      1: (EG: TsgGroupType; ET: TsgEntityTypeEx);
  end;

const
  cnstGroupTypeName: array [TsgGroupType] of string = ('', 'BTI', 'SVG');

  cnstUndefined = -1;
  cnstDimConstruction = MAXBYTE;
  cnstConstruction = 0;
  cnstComplex = 1;
  cnstElement = 2;
  cnstComplexBroad = 3;
  cnstComplexLinear = 4;
  cnstElementBroad = 5;
  cnstElementLinear = 6;
  cnstElementCarved = 7;
  cnstElementModifier = 8;
  cnstArea = 16;
  cnstComplexArea = 17;
  cnstLabel = 32;
  cnstDimLabel = 33;
  cnstBlockPattern = MaxInt;
  cnstIllegal = -$5555 * 65536.0 * 65536.0;

  cnstDefHeadVarStruct: TsgHeadVarStruct =
    (
      CEColor: clByLayer;
      CLayer: '0';
      CELType: sByLayer;
      CELTScale: 1;
      CELWeight: -1.0;//fLineWeightByLayer;
      CodePage: 0;
      DimStyle: sStandardName;
      DimTextStyle: sStandardName;      
      DimProps: (
        Alt: False;
        AltF: 1;
        APost: '';
        Asz: 0.18;
        Blk: Low(sgDimensionArrowTypeNames);//CLOSEDFILLED';
        Blk1: MAXBYTE;//''
        Blk2: MAXBYTE;//''
        LrBlk: MAXBYTE;//''
        Cen: 0;
        ClrD: clByBlock;
        ClrE: clByBlock;
        ClrT: clByBlock;
        SD1: False;
        SD2: False;
        SE1: False;
        SE2: False;
        Dec: 4;
        Exe: 0.18;
        Exo: 0.0625;
        Gap: 0.0625;
        LFac: 1;
        LwD: -1.0;//fLineWeightByLayer;
        LwE: -1.0;//fLineWeightByLayer;
        Post: '';
        Scale: 1.0;
        Tad: 0;
        Tih: True;
        Tix: 0;
        Toh: True;
        Txt: 0.18; );
      TextStyle: sStandardName;
      FilletRadius: 0.5;
      InsUnits: Byte(iuMillimeters);
      LScale: 1;
      Measurement: False;
      PointDisplayMode: 0;
      PointDisplaySize: 0;
      TextSize: 0.18;
      TileMode: 1;
      UCSORG:  (X: 0; Y: 0; Z: 0);
      UCSXDir: (X: 1; Y: 0; Z: 0);
      UCSYDir: (X: 0; Y: 1; Z: 0);
      Version: 0;
    );

  cnstSGHeadVarStruct: TsgHeadVarStruct =
    (
      CEColor: clByLayer;
      CLayer: '0';
      CELType: sByLayer;
{$IFDEF SG_UNITS_MM}
      CELTScale: 30;
{$ELSE}
      CELTScale: 1;
{$ENDIF}
      CELWeight: -1.0;//fLineWeightByLayer;
      CodePage: 0;
      DimStyle: sStandardName;
      DimTextStyle: sStandardName;
      DimProps: (
        Alt: False;
        AltF: 1;
        APost: '';
{$IFDEF SG_UNITS_MM}
        Asz: 250;
{$ELSE}
        Asz: 2.5;
{$ENDIF}
        Blk: Low(sgDimensionArrowTypeNames);//'_CLOSEDFILLED';
        Blk1: MAXBYTE;//'';
        Blk2: MAXBYTE;//'';
        LrBlk: MAXBYTE;//'';
        Cen: 0;
        ClrD: clByBlock;
        ClrE: clByBlock;
        ClrT: clByBlock;
        SD1: False;
        SD2: False;
        SE1: False;
        SE2: False;
        Dec: 2;
{$IFDEF SG_UNITS_MM}
        Exe: 250;
        Exo: 80;
        Gap: 80;
        LFac: 0.001;
{$ELSE}
        Exe: 2.5;
        Exo: 0.868;
        Gap: 0.868;
        LFac: 1;
{$ENDIF}
        LwD: -1.0;//fLineWeightByLayer;
        LwE: -1.0;//fLineWeightByLayer;
        Post: '';
        Scale: 1.0;
        Tad: 0;
        Tih: False;
        Tix: 0;
        Toh: False;
        Txt:
{$IFDEF SG_UNITS_MM}
             250
{$ELSE}
             2.5
{$ENDIF};
         );
      TextStyle: sStandardName;
{$IFDEF SG_UNITS_MM}
      FilletRadius: 250;
      InsUnits: Byte(iuMillimeters);
{$ELSE}
      FilletRadius: 0.5;
      InsUnits: Byte(iuMeters);
{$ENDIF}
      LScale: 1;
      Measurement: False;
      PointDisplayMode: 0;
{$IFDEF SG_UNITS_MM}
      PointDisplaySize: 50;
      TextSize: 250;
{$ELSE}
      PointDisplaySize: 0;
      TextSize: 2.5;
{$ENDIF}
      TileMode: 1;
      UCSORG:  (X: 0; Y: 0; Z: 0);
      UCSXDir: (X: 1; Y: 0; Z: 0);
      UCSYDir: (X: 0; Y: 1; Z: 0);
      Version: 0;
    );

  bCachingRasterMode: TsgCachingRasterMode = crmCache;
  cnstFPointSize = SizeOf(TFPoint) div SizeOf(Pointer);
  cnstFPointIllegal: TFPoint = (X:cnstIllegal; Y:cnstIllegal; Z:0);
  cnstFPointZero: TFPoint = ();
  cnstFPointSingle: TFPoint = (X:1; Y:1; Z:1);
  cnstExtrusion: TFPoint = (X: 0; Y: 0; Z: 1);
  cnstXOrtAxis: TFPoint = (X: 1; Y: 0; Z: 0);
  cnstYOrtAxis: TFPoint = (X: 0; Y: 1; Z: 0);
  cnstZOrtAxis: TFPoint = (X: 0; Y: 0; Z: 1);
  cnstF2DPointZero: TF2DPoint = ();
  cnstBad2DRect: TRect = (Left:$7FFF; Top:$7FFF; Right:-$7FFF; Bottom:-$7FFF);
  cnstBadRect: TFRect = (Left: 1E20; Top: -1E20; Z1: 1E20; Right:-1E20; Bottom: 1E20; Z2: -1E20);
  cnstBadRectF2D: TF2DRect = (Left: 1E20; Top: -1E20; Right:-1E20; Bottom: 1E20);
  cnstIdentityMat: TFMatrix = (M:((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0)));
  cnstCrossYMat: TFMatrix = (M:((1, 0, 0), (0, -1, 0), (0, 0, 1), (0, 0, 0)));
  cnstBorderSize: Double = 1 / 8;
  cnstBorderType: TsgBorderType = btRatio;
  cnstFontParamsZero: TsgFontParams = ();
  cnstSizePrecision: array [0..8] of Byte = (0, 1, 2, 3, 4, 5, 6, 7, 8);
  cnstSizeScale: array [0..24] of Double = (10000, 5000, 2000, 1000, 500, 200, 100,
    50, 20, 10, 5, 2, 1, 0.5, 0.2, 0.1, 0.05, 0.02, 0.01, 0.005, 0.002, 0.001,
    0.0005, 0.0002, 0.0001);

  cnstViewBoxZero: TsgViewBox = ();
  cnstIniHeadVar: TsgLittleHeadVarStruct = ();

  cnstSnapMaskAll: TObjectSnapState =[osInsert, osEndPt, osCenter, osNode, osMiddle,
    osNearest, osIntersection, osNormal, osExtension];
  cnstSnapMaskNone: TObjectSnapState = [osDisabled];
  cnstUseProxy: Boolean = False;
  cnstProxyInfo: TsgHTTPProxyInfo = (
    ProxyHost: '';
    ProxyPort: 0;
    ProxyNeedPass: False;
    ProxyUser: '';
    ProxyPass: '' );
  cnstTypeDP = '%%';
  cnstTypeU = '\U+';
  cnstTypeM = '\M+';

{$IFDEF SG_BTI}
  cnstActivePoint: TsgActivePoint = apLeftTop;
  cnstActiveAxis: TsgAxisType = atLeft;
  cnstBoundaryVisible: Boolean = True;
  sBoundaryVisible = 'BoundaryVisible';
  cnstAreaCreateMode: Integer = 2;

  cnstAreaFigues: array [TsgFigureType] of string =
    ('Figure', 'Quadrangle', 'Trapezium', 'Parallelogram', 'Rect', 'Square', 'Rhomb',
     'Segment by chord and length', 'Segment by chord and height', 'Triangle', 'Right triangle',
     'Triangle by hippuran', 'Circle by length', 'Circle by radius', 'Sector by angle and radius', 'Contour');
{$ENDIF}

function BadRect: TFRect;
function BinSearch(List: TList; Comp: TListSortCompare; var Index: Integer; var Param): Boolean;
function Degree(ARadian: Extended): Extended;
procedure CheckHeadVar(const H: PsgHeadVarStruct);
procedure ClearList(AList: TList);
procedure ClearListOfList(AListOfList: TList);
procedure ClearRecordList(AList: TList);
procedure ClearRecordListOfList(AListOfList: TList);
procedure ClearListWithNilCheck(List: TList);
procedure DisposeDeleteFromList(AList: TList; const AIndex: Integer); // don't use for record with strings!
function CompareDXFPointByXCoord(Item1, Item2: Pointer): Integer;
function CompareDXFPointByYCoord(Item1, Item2: Pointer): Integer;
function CompareFPointByXCoord(Item1, Item2: Pointer): Integer;
function CompareFPointByYCoord(Item1, Item2: Pointer): Integer;
function ConvToFloatDef(const S: string; const Value: Extended): Extended;
procedure ExpandFRect(var R: TFRect; const P: TFPoint);
function FindSHXPaths(const APaths: TStringList): Boolean;
function FindAutoCADSHXPaths(APaths: TStringList): Boolean;
function FindDWGTrueViewSHXPaths(APaths: TStringList): Boolean;
procedure SetSHXSearchPaths(const APaths: TStringList);
procedure FreeList(var AList: TList);
procedure FreeRecordList(var AList: TList);
procedure FreeRecordListOfList(var AListOfList: TList);
function GetAccuracy(const ALength: Double): Double;
function GetAccuracyByFPoints(const APt1, APt2: TFPoint): Double;
function MakeDXFPoint(const X, Y, Z: Single): TdxfPoint;
function MakeFPoint(X, Y, Z: TsgFloat): TFPoint;
function MakeF2DPoint(const X, Y: TsgFloat): TF2DPoint;
function MakeF2DPointFrom3D(const APoint: TFPoint): TF2DPoint;
function MakeFRect(Left, Top, Z1, Right, Bottom, Z2: TsgFloat): TFRect;
function MakeFRectByPoints(const LeftTop, RightBottom: TFPoint): TFRect;
function MakeF2DRect(const Left, Top, Right, Bottom: TsgFloat): TF2DRect;
function MakeF2DRectByPoints(const LeftTop, RightBottom: TF2DPoint): TF2DRect;
function MakeDXFFromFPoint(const AFPoint: TFPoint): TdxfPoint;
function MakeFPointFromDXF(const AdxfPoint: TdxfPoint): TFPoint;
function MakeLine(const AP1, AP2: TFPoint): TsgLine;
function MakeRightPath(APath: string): string;
function FloatPoint(X, Y: Extended): TFPoint;
function FloatRect(ALeft, ATop, ARight, ABottom: Extended): TFRect;
function FltPoint3D(X, Y, Z: Extended): TFPoint;
function IdentityMat: TFMatrix;
function IsBadRect(ARect: TFRect): Boolean;
function IsEqual(const AVal1, AVal2: TsgFloat): Boolean;
function IsEqualPoints(const Point1, Point2: TPoint): Boolean;
function IsEqualFPoints(const Point1, Point2: TFPoint): Boolean;
function IsEqualFPoints2D(const Point1, Point2: TFPoint): Boolean;
function IsEqualF2DPoints(const Point1, Point2: TF2DPoint): Boolean;
function TransposeMat(const AMatrix: TFMatrix): TFMatrix;
procedure TransRectCorners(var ARect: TFRect; const AMatrix: TFMatrix);
function IsRotated(const M: TFMatrix): Boolean;
function LCIDToCodePage(const ALcid: LCID): Integer;
//function MatFromExtr(const P: TFPoint; Angle: Single): TFMatrix;
procedure MatOffset(var M: TFMatrix; const P: TFPoint);
function MatXMat(const A,B: TFMatrix): TFMatrix;
function PtXMat(const P: TFPoint; const M: TFMatrix): TFPoint; {$IFDEF SG_FAST_CODE} assembler; register; {$ENDIF}
function CalcPoint(const P: TFPoint; const M: TFMatrix): TPoint; {$IFDEF SG_FAST_CODE} assembler; register; {$ENDIF}
function ScalarXMat(const AVal: TsgFloat; const M: TFMatrix): TsgFloat;
function ScalarXMatByY(const AVal: TsgFloat; const M: TFMatrix): TsgFloat;
function ScalarXMatByZ(const AVal: TsgFloat; const M: TFMatrix): TsgFloat;
function Radian(Angle: Extended): Extended;
procedure ReplaceAnsi(var S: string; const S1, S2: string);
procedure sgNOP;  {$IFDEF SGDEL_2006} experimental; {$ENDIF}
procedure SortList(AList: PPointerList; ACompareFunc: TListSortCompare;
  ALeftPos, ARightPos: Integer);
function StdMat(const S, P: TFPoint): TFMatrix;
procedure SwapInts(var A,B);
procedure SwapFPoints(var A,B: TFPoint);
procedure SwapSGFloats(var A, B: TsgFloat);
function PointClassify(p, p0, p1: TFPoint): TsgPointClassify;
function Proportional(const XInput, YInput, AOutput: TsgFloat; AOutputIsX : Boolean): TsgFloat; //For internal using
function Min(const A, B: Double): Double;
function Max(const A, B: Double): Double;
function MinI(const A, B: Integer): Integer;
function MaxI(const A, B: Integer): Integer;
function GetIntersectingPoint(const Line1, Line2: TsgLine; var IntersectionMode: TIntersectionMode): TFPoint;
function GetIntresectingRectAndLine(const ARect: TFRect; const ALine: TsgLine; var IntersectionMode: TIntersectionMode): TsgLine;
function MaxTsgFloat: Extended;
function DistanceF(APoint1, APoint2: TFPoint): Double;
function DistanceI(APoint1, APoint2: TPoint): Double;
function IntToColor(Value: Integer): TColor;

function GetNameByEntTypeEx(const AType: Integer): string;

function CreateParamData: PsgParamData;
procedure ClearParamData(const AParam: PsgParamData);
procedure DisposeParamData(var AParam: PsgParamData);
function GetArrowTypeByName(AName: string; const DefValue: Byte): Byte;
function GetNameByArrowType(const AType: Byte; const DefValue: string): string;

function StringHexToIntDef(const AStr: string; ADef: Integer): UInt64;
function GetMultibyteSymbol(const ALeft, ARight: Byte; const ANumber: Integer): WideChar;
function ConvertToWideString(const AText: AnsiString; const ACodePage: Integer): WideString;
function ConvertToAnsiString(const AText: WideString; const ACodePage: Integer): sgRawByteString;
function StringToACADPresentation(const AString: sgUnicodeStr; const ACodePage: Integer): sgRawByteString;
function ParseUnicode(AStr: sgUnicodeStr; AModes: TParseUnicodeModes): sgUnicodeStr;
function IsDigit(AChar: Char): Boolean; {$IFNDEF SGDEL_2009} overload; {$ENDIF}
{$IFNDEF SGDEL_2009}
function IsDigit(AChar: WideChar): Boolean; overload;
{$ENDIF}

{$IFNDEF SGDEL_6}
function WideUpperCase(const S: WideString): WideString;
{$ENDIF}

{$IFDEF SGDEL_7}
{$IFDEF SG_USE_INDY}
function GetDataFromHttp(const AHost: string; AStream: TStream; TimeOut: Integer;
  var AFileName: string; const AProxyInfo: TsgHTTPProxyInfo;
  AUseProxy: Boolean = False): Boolean;
{$ENDIF}
{$ENDIF}

function GetBTITypeByEntTypeEx(const ATypeEx: Integer): TbtiEntity;

{$IFNDEF SGDEL_2009}
type
  TSysCharSet = set of AnsiChar;

function AnsiStrAlloc(Size: Cardinal): PAnsiChar;
function CharInSet(C: AnsiChar; const CharSet: TSysCharSet): Boolean; overload;
function CharInSet(C: WideChar; const CharSet: TSysCharSet): Boolean; overload;
{$ENDIF}

implementation

uses Math, SysUtils;

{$IFDEF SG_FAST_CODE}
const
  MxInt: Integer = MaxInt;
{$ENDIF}

function IntToColor(Value: Integer): TColor;
begin
  Result := Value;
  if Result < 0 then
    Exit;
  Result := clByLayer;
  if Value = 0 then
    Result := clByBlock
  else
    if (Value > 0) and (Value < 256) then
    begin
      if (Value <> 7) then
        Result := TColor(arrDXFtoRGBColors[Value])
      else
        Result := clNone;
    end;
end;

function BadRect: TFRect;
begin
  Result := cnstBadRect;
end;

function BinSearch(List: TList; Comp: TListSortCompare; var Index: Integer; var Param): Boolean;
var
  C,L,R: Integer;
begin
  Result := False;
  Index := 0;
  L := 0;
  R := List.Count;
  while True do
  begin
    Index := (L + R) shr 1;
    if L = R then
      Exit;
    C := Comp(List[Index], @Param);
    Result := C=0;
    if Result then
      Exit;
    if C > 0 then
      R := Index
    else
      L := Index+1;
  end;
end;

function Proportional(const XInput, YInput, AOutput: TsgFloat; AOutputIsX : Boolean): TsgFloat;
begin
  if (XInput = 0)or(YInput = 0) then
  begin
    Result := AOutput;
    Exit;
  end;
  if AOutputIsX then
    Result := YInput * AOutput / XInput
  else
    Result := XInput * AOutput / YInput;
end;

function ConvToFloatDef(const S: string; const Value: Extended): Extended;
var
  E: Integer;
begin
  Val(S, Result, E);
  if E <> 0 then
  begin
    Dec(E);
    Val(Copy(S, 1, E), Result, E);
    if (E <> 0) and (Result = 0) then
      Result := Value;
  end;
end;

procedure ExpandFRect(var R: TFRect; const P: TFPoint);
begin
  if R.Left > P.X then
    R.Left := P.X;
  if R.Top < P.Y then
    R.Top := P.Y;
  if R.Z1 > P.Z then
    R.Z1 := P.Z;
  if R.Right < P.X then
    R.Right := P.X;
  if R.Bottom > P.Y then
    R.Bottom := P.Y;
  if R.Z2 < P.Z then
    R.Z2 := P.Z;
end;

function Degree(ARadian: Extended): Extended;
begin
  Result := ARadian * f180DividedByPi;
end;

function GetAccuracy(const ALength: Double): Double;
begin
  Result := Max(ALength * fDoubleResolution, fDoubleResolution);
end;

function GetAccuracyByFPoints(const APt1, APt2: TFPoint): Double;
begin
  Result := GetAccuracy(DistanceF(APt1, APt2));
end;

function MakeDXFPoint(const X, Y, Z: Single): TdxfPoint;
begin
  Result.X := X;
  Result.Y := Y;
  Result.Z := Z;
end;

function MakeFPoint(X, Y, Z: TsgFloat): TFPoint;
begin
  Result.X := X;
  Result.Y := Y;
  Result.Z := Z;
end;

function MakeF2DPoint(const X, Y: TsgFloat): TF2DPoint;
begin
  Result.X := X;
  Result.Y := Y;
end;

function MakeF2DPointFrom3D(const APoint: TFPoint): TF2DPoint;
begin
  Result.X := APoint.X;
  Result.Y := APoint.Y;
end;

function MakeFRect(Left, Top, Z1, Right, Bottom, Z2: TsgFloat): TFRect;
begin
  Result.Left := Left;
  Result.Top := Top;
  Result.Z1 := Z1;
  Result.Right := Right;
  Result.Bottom := Bottom;
  Result.Z2 := Z2;
end;

function MakeFRectByPoints(const LeftTop, RightBottom: TFPoint): TFRect;
begin
  Result.TopLeft := LeftTop;
  Result.BottomRight := RightBottom;
end;

function MakeF2DRect(const Left, Top, Right, Bottom: TsgFloat): TF2DRect;
begin
  Result.Left := Left;
  Result.Top := Top;
  Result.Right := Right;
  Result.Bottom := Bottom;
end;

function MakeF2DRectByPoints(const LeftTop, RightBottom: TF2DPoint): TF2DRect;
begin
  Result.TopLeft := LeftTop;
  Result.BottomRight := RightBottom;
end;

function MakeFPointFromDXF(const AdxfPoint: TdxfPoint): TFPoint;
begin
  Result.X := AdxfPoint.X;
  Result.Y := AdxfPoint.Y;
  Result.Z := AdxfPoint.Z;
end;

function MakeDXFFromFPoint(const AFPoint: TFPoint): TdxfPoint;
begin
  Result.X := AFPoint.X;
  Result.Y := AFPoint.Y;
  Result.Z := AFPoint.Z;
end;

function MakeLine(const AP1, AP2: TFPoint): TsgLine;
begin
  Result.Point1 := AP1;
  Result.Point2 := AP2;
end;

function MakeRightPath(APath: string): string;
var
  L: Integer;
begin
  L := Length(APath);
  if L > 0 then
    if APath[L] <> '\' then
      APath := APath + '\';
  Result := APath;
end;

function FloatPoint(X, Y: Extended): TFPoint;
begin
  Result.X := X;
  Result.Y := Y;
  Result.Z := 0;
end;

function FloatRect(ALeft, ATop, ARight, ABottom: Extended): TFRect;
begin
  Result.Left := ALeft;
  Result.Top := ATop;
  Result.Z1 := 0;
  Result.Right := ARight;
  Result.Bottom := ABottom;
  Result.Z2 := 0;
end;

function FltPoint3D(X, Y, Z: Extended): TFPoint;
begin
  Result.X := X;
  Result.Y := Y;
  Result.Z := Z;
end;

function Radian(Angle: Extended): Extended;
begin
  Result := Angle * fPiDividedBy180;
end;

procedure ReplaceAnsi(var S: string; const S1, S2: string);
var
  P, Counter, Len1, Len2: Integer;
  vStr, vStr1: string;
begin
  vStr := Lowercase(S);
  vStr1 := Lowercase(S1);
  Len1 := Length(S1);
  Len2 := Length(S2);
  Counter := 0;
  while True do
  begin
    P := Pos(vStr1, vStr);
    if P = 0 then
      Exit;
    Delete(vStr, 1, P + Len1 - 1);
    Delete(S, P + Counter, Len1);
    Inc(Counter, P);
    if S2 <> '' then
    begin
      Insert(S2, S, Counter);
      Inc(Counter, Len2-1);
    end;
  end;
end;

procedure sgNOP; // only for debug
asm
  NOP
end;

procedure SwapSGFloats(var A, B: TsgFloat);
var
  C: TsgFloat;
begin
  C := A;
  A := B;
  B := C;
end;

// fastest more then 10 times
function PtXMat(const P: TFPoint; const M: TFMatrix): TFPoint; {$IFDEF SG_FAST_CODE} assembler; register; {$ENDIF}
{$IFDEF SG_FAST_CODE}
asm
  fld qword ptr [eax]
  fld ST(0)
  fmul qword ptr [edx]
  fld qword ptr [eax+$08]
  fmul qword ptr [edx+$18]
  faddp
  fld qword ptr [eax+$10]
  fmul qword ptr [edx+$30]
  faddp
  fadd qword ptr [edx+$48]
  fstp qword ptr [ecx]
  wait

  fld ST(0)
  fmul qword ptr [edx+$08]
  fld qword ptr [eax+$08]
  fmul qword ptr [edx+$20]
  faddp
  fld qword ptr [eax+$10]
  fmul qword ptr [edx+$38]
  faddp
  fadd qword ptr [edx+$50]
  fstp qword ptr [ecx+$08]
  wait

  fmul qword ptr [edx+$10]
  fld qword ptr [eax+$08]
  fmul qword ptr [edx+$28]
  faddp
  fld qword ptr [eax+$10]
  fmul qword ptr [edx+$40]
  faddp
  fadd qword ptr [edx+$58]
  fstp qword ptr [ecx+$10]
  wait
end;
{$ELSE}
  function Part(I: Integer): Extended;
  begin
    Result := P.X * M.M[0,I] + P.Y * M.M[1,I] + P.Z * M.M[2,I] + M.M[3,I];
  end;
begin
  Result.X := Part(0);
  Result.Y := Part(1);
  Result.Z := Part(2);
end;
{$ENDIF}

// fastest more then 2.5 times
function CalcPoint(const P: TFPoint; const M: TFMatrix): TPoint; {$IFDEF SG_FAST_CODE} assembler; register; {$ENDIF}
{$IFDEF SG_FAST_CODE}
// EAX: P
// EDX: M
// ECX: Result
asm
  push esi
  mov esi,eax
  fld qword ptr [esi]     // P.x
  fld ST(0)               // P.x
  fmul qword ptr [edx]    // P.x * M[0,0]
  fld qword ptr [esi+$08] // P.Y
  fmul qword ptr [edx+$18]// P.Y * M[1,0]
  faddp                   // ST(0) = ST(1) + ST(0)
  fld qword ptr [esi+$10] // P.Z
  fmul qword ptr [edx+$30]// P.Z * M[2,0]
  faddp                   // ST(0) = ST(1) + ST(0)
  fadd qword ptr [edx+$48]// ST(0) = ST(0) + M[3,0]
  fld ST(0)               // load FPU stack by ST(0)
  fabs                    // ST(0) = Absolute ST(0)
  fild dword ptr [MxInt]  // load $7FFFFFFF (Max Integer)
  fcompp                  // Compare Absolute ST(1) and $7FFFFFFF
  fstsw ax                // FPU state to ax
  sahf                    // load ah to flag's register
  jbe @BigValueX          // if Absolute ST(1) more then $7FFFFFFF jump to set Result.X := $7FFFFFFF
  fistp dword ptr [ecx]   // else Result.X := Round(ST(0))

@calcy:
  fmul qword ptr [edx+$08]// P.X * M[0, 1]
  fld qword ptr [esi+$08] // Load P.Y
  fmul qword ptr [edx+$20]// P.Y * M[1, 1]
  faddp                   // ST(0) = ST(1) + ST(0)
  fld qword ptr [esi+$10] // Load P.Z
  fmul qword ptr [edx+$38]// P.Z * M[2, 1]
  faddp                   // ST(0) = ST(1) + ST(0)
  fadd qword ptr [edx+$50]// ST(0) = M[3, 1] + ST(0)
  fld ST(0)               // Load ST(1) = ST(0)
  fabs                    // Absolute ST(0)
  fild dword ptr [MxInt]  // load $7FFFFFFF (Max Integer)
  fcompp                  // Compare Absolute ST(1) and $7FFFFFFF
  fstsw ax                // FPU state to ax
  sahf                    // load ah to flag's register
  jbe @BigValueY          // if Absolute ST(1) more then $7FFFFFFF jump to set Result.Y := $7FFFFFFF
  fistp dword ptr [ecx+$04]// else Result.Y := Round(ST(0))
  wait                    // wait FPU memory operation
  pop esi                 // restore esi
  ret
@BigValueX:
  fstp ST(0)              // pop FPU stack
  wait                    // wait FPU memory operation
  mov eax,MxInt
  mov [ecx],eax           // set Result.X := $7FFFFFFF (Max Integer)
  jmp @calcy              // jump to calc Result.Y
@BigValueY:
  fstp ST(0)              // pop FPU stack
  wait                    // wait FPU memory operation
  mov eax,MxInt
  mov [ecx+$04],eax       // set Result.Y := $7FFFFFFF (Max Integer)
@exitf:
  pop esi                 // restore esi
end;
{$ELSE}
var
  R: TsgFloat;
begin
  R := P.X * M.M[0, 0] + P.Y * M.M[1, 0] +
    P.Z * M.M[2, 0] + M.M[3, 0];
  if Abs(R) < MaxInt then
    Result.X := Round(R)
  else
    Result.X := MaxInt;

  R := P.X * M.M[0, 1] + P.Y * M.M[1, 1] +
    P.Z * M.M[2, 1] + M.M[3, 1];
  if Abs(R) < MaxInt then
    Result.Y := Round(R)
  else
    Result.Y := MaxInt;
end;
{$ENDIF}

// fastest more then 2 times
function MatXMat(const A, B: TFMatrix): TFMatrix;
{$IFDEF SG_FAST_CODE}
begin
  Result.M[0,0] := A.M[0,0] * B.M[0,0] + A.M[0,1] * B.M[1,0] + A.M[0,2] * B.M[2,0];
  Result.M[1,0] := A.M[1,0] * B.M[0,0] + A.M[1,1] * B.M[1,0] + A.M[1,2] * B.M[2,0];
  Result.M[2,0] := A.M[2,0] * B.M[0,0] + A.M[2,1] * B.M[1,0] + A.M[2,2] * B.M[2,0];
  Result.M[3,0] := A.M[3,0] * B.M[0,0] + A.M[3,1] * B.M[1,0] + A.M[3,2] * B.M[2,0] + B.M[3,0];

  Result.M[0,1] := A.M[0,0] * B.M[0,1] + A.M[0,1] * B.M[1,1] + A.M[0,2] * B.M[2,1];
  Result.M[1,1] := A.M[1,0] * B.M[0,1] + A.M[1,1] * B.M[1,1] + A.M[1,2] * B.M[2,1];
  Result.M[2,1] := A.M[2,0] * B.M[0,1] + A.M[2,1] * B.M[1,1] + A.M[2,2] * B.M[2,1];
  Result.M[3,1] := A.M[3,0] * B.M[0,1] + A.M[3,1] * B.M[1,1] + A.M[3,2] * B.M[2,1] + B.M[3,1];

  Result.M[0,2] := A.M[0,0] * B.M[0,2] + A.M[0,1] * B.M[1,2] + A.M[0,2] * B.M[2,2];
  Result.M[1,2] := A.M[1,0] * B.M[0,2] + A.M[1,1] * B.M[1,2] + A.M[1,2] * B.M[2,2];
  Result.M[2,2] := A.M[2,0] * B.M[0,2] + A.M[2,1] * B.M[1,2] + A.M[2,2] * B.M[2,2];
  Result.M[3,2] := A.M[3,0] * B.M[0,2] + A.M[3,1] * B.M[1,2] + A.M[3,2] * B.M[2,2] + B.M[3,2];
end;
{$ELSE}
var
  I,J: Integer;
begin
  for I := 0 to 3 do
  begin
    for J := 0 to 2 do
      Result.M[I,J] := A.M[I,0] * B.M[0,J] + A.M[I,1] * B.M[1,J] + A.M[I,2] * B.M[2,J];
  end;
  for J := 0 to 2 do
    Result.M[3,J] := Result.M[3,J] + B.M[3,J];
end;
{$ENDIF}

function ScalarXMat(const AVal: TsgFloat; const M: TFMatrix): TsgFloat;
var
  vM: TFMatrix;
begin
  vM := M;
  MatOffset(vM, cnstFPointZero);
  Result := DistanceF(MakeFPoint(0,0,0), PtXMat(MakeFPoint(AVal,0,0), vM));
end;

function ScalarXMatByY(const AVal: TsgFloat; const M: TFMatrix): TsgFloat;
var
  vM: TFMatrix;
begin
  vM := M;
  MatOffset(vM, cnstFPointZero);
  Result := DistanceF(MakeFPoint(0,0,0), PtXMat(MakeFPoint(0,AVal,0), vM));
end;

function ScalarXMatByZ(const AVal: TsgFloat; const M: TFMatrix): TsgFloat;
var
  vM: TFMatrix;
begin
  vM := M;
  MatOffset(vM, cnstFPointZero);
  Result := DistanceF(MakeFPoint(0,0,0), PtXMat(MakeFPoint(0,0,AVal), vM));
end;

function IsRotated(const M: TFMatrix): Boolean;
var
  I,J: Integer;
begin
  Result := False;
  for I := 0 to 2 do
  begin
    for J := 0 to 2 do
    begin
      if I = J then
        Continue;
      Result := Abs(M.M[I,J]) > fAccuracy;
      if Result then
        Exit;
    end;
  end;
end;

function LCIDToCodePage(const ALcid: LCID): Integer;
var
  Buffer: array [0..6] of Char;
  Err: Integer;
begin
  if GetLocaleInfo(ALcid, LOCALE_IDEFAULTANSICODEPAGE, Buffer, SizeOf(Buffer)) <> 0 then
  begin
    Val(Buffer, Result, Err);
    if Err > 0 then Result := GetACP;
  end
  else Result := GetACP;
end;

procedure MatOffset(var M: TFMatrix; const P: TFPoint);
begin
  M.M[3,0] := P.X;
  M.M[3,1] := P.Y;
  M.M[3,2] := P.Z;
end;

function StdMat(const S,P: TFPoint): TFMatrix;
begin
  FillChar(Result, SizeOf(Result), 0);
  Result.M[0,0] := S.X;
  Result.M[1,1] := S.Y;
  Result.M[2,2] := S.Z;
  MatOffset(Result,P);
end;

function IdentityMat: TFMatrix;
begin
  FillChar(Result, SizeOf(Result), 0);
  Result.M[0,0] := 1;
  Result.M[1,1] := 1;
  Result.M[2,2] := 1;
end;

function TransposeMat(const AMatrix: TFMatrix): TFMatrix;
begin
  Result.M[0, 0] := AMatrix.M[0,0];
  Result.M[1, 0] := AMatrix.M[0,1];
  Result.M[2, 0] := AMatrix.M[0,2];
  Result.M[0, 1] := AMatrix.M[1,0];
  Result.M[1, 1] := AMatrix.M[1,1];
  Result.M[2, 1] := AMatrix.M[1,2];
  Result.M[0, 2] := AMatrix.M[2,0];
  Result.M[1, 2] := AMatrix.M[2,1];
  Result.M[2, 2] := AMatrix.M[2,2];
  Result.M[3, 0] := -AMatrix.M[3,0];
  Result.M[3, 1] := -AMatrix.M[3,1];
  Result.M[3, 2] := -AMatrix.M[3,2];
end;

procedure TransRectCorners(var ARect: TFRect; const AMatrix: TFMatrix);
var
  R: TFRect;

  procedure ExpR(const X, Y, Z: TsgFloat);
  begin
    ExpandFRect(R, PtXMat(MakeFPoint(X, Y, Z), AMatrix));
  end;

begin
  R := cnstBadRect;
  ExpR(ARect.Left, ARect.Top, ARect.Z1);
  ExpR(ARect.Left, ARect.Top, ARect.Z2);
  ExpR(ARect.Left, ARect.Bottom, ARect.Z1);
  ExpR(ARect.Left, ARect.Bottom, ARect.Z2);
  ExpR(ARect.Right, ARect.Top, ARect.Z1);
  ExpR(ARect.Right, ARect.Top, ARect.Z2);
  ExpR(ARect.Right, ARect.Bottom, ARect.Z1);
  ExpR(ARect.Right, ARect.Bottom, ARect.Z2);
  ARect := R;
end;

{ SortList

  Sorts the list. }
procedure SortList(AList: PPointerList; ACompareFunc: TListSortCompare;
  ALeftPos, ARightPos: Integer);
var
  K, N: Integer;
  PItem, PElem: Pointer;
begin
  repeat
    K := ALeftPos;
    N := ARightPos;
    PItem := AList^[(ALeftPos + ARightPos) shr 1];
    repeat
      while ACompareFunc(AList^[K], PItem) < 0 do
        Inc(K);
      while ACompareFunc(AList^[N], PItem) > 0 do
        Dec(N);
      if K <= N then
      begin
        PElem := AList^[K];
        AList^[K] := AList^[N];
        AList^[N] := PElem;
        Inc(K);
        Dec(N);
      end;
    until (K > N);
    if ALeftPos < N then
      SortList(AList, ACompareFunc, ALeftPos, N);
    ALeftPos := K;
  until (K >= ARightPos);
end;

function CompareDXFPointByXCoord(Item1, Item2: Pointer): Integer;
begin
  if(PdxfPoint(Item1)^.X> PdxfPoint(Item2)^.X) then
    Result := +1
  else if(PdxfPoint(Item1)^.X = PdxfPoint(Item2)^.X) then
    Result := 0
  else
    Result := -1;
end;

function CompareDXFPointByYCoord(Item1, Item2: Pointer): Integer;
begin
  if(PdxfPoint(Item1)^.Y> PdxfPoint(Item2)^.Y) then
    Result := +1
  else if(PdxfPoint(Item1)^.Y = PdxfPoint(Item2)^.Y) then
    Result := 0
  else
    Result := -1;
end;

function CompareFPointByXCoord(Item1, Item2: Pointer): Integer;
begin
  if(PFPoint(Item1)^.X> PFPoint(Item2)^.X) then
    Result := +1
  else if(PFPoint(Item1)^.X = PFPoint(Item2)^.X) then
    Result := 0
  else
    Result := -1;
end;

function CompareFPointByYCoord(Item1, Item2: Pointer): Integer;
begin
  if(PFPoint(Item1)^.Y> PFPoint(Item2)^.Y) then
    Result := +1
  else if(PFPoint(Item1)^.Y = PFPoint(Item2)^.Y) then
    Result := 0
  else
    Result := -1;
end;

procedure CheckHeadVar(const H: PsgHeadVarStruct);
begin
  if cnstIniHeadVar.InitFlags and 1 <> 0 then
  begin
    if cnstIniHeadVar.InitFlags and 2 <> 0 then
      H^.DimProps.Dec := cnstIniHeadVar.DimDec;
    if cnstIniHeadVar.InitFlags and 4 <> 0 then
      H^.DimProps.LFac := cnstIniHeadVar.DimLFac;
    if cnstIniHeadVar.InitFlags and 8 <> 0 then
      H^.DimProps.Txt := cnstIniHeadVar.DimTxt;
    if cnstIniHeadVar.InitFlags and 16 <> 0 then
    begin
      case cnstIniHeadVar.DimTextAlign of
        1://align
          begin
            H^.DimProps.TIH := False;
            H^.DimProps.TOH := False;
          end;
        2://ISO
          begin
            H^.DimProps.TIH := False;
            H^.DimProps.TOH := True;
          end;
      else//gorizontal - default
        H^.DimProps.TIH := True;
        H^.DimProps.TOH := True;
      end;
    end;
    if cnstIniHeadVar.InitFlags and 32 <> 0 then
      H^.DimProps.ClrT := cnstIniHeadVar.DimClrT;
    if cnstIniHeadVar.InitFlags and 64 <> 0 then
      H^.DimProps.Gap := cnstIniHeadVar.DimGap;
  end;
end;

procedure ClearList(AList: TList);
var
  I: Integer;
begin
  if AList = nil then
    Exit;
  for I := 0 to AList.Count - 1 do
    TObject(AList[I]).Free;
  AList.Clear;
end;

procedure ClearListOfList(AListOfList: TList);
var
  I, K: Integer;
  vList: TList;
begin
  if AListOfList = nil then
    Exit;
  for I := AListOfList.Count - 1 downto 0 do
    if AListOfList.List^[I] <> nil then
    begin
      vList := AListOfList.List^[I];
      for K := vList.Count - 1 downto 0 do
        if vList.List^[K] <> nil then
          TObject(vList.List^[K]).Free;
      vList.Free;
    end;
  AListOfList.Clear;
end;

procedure ClearRecordList(AList: TList);
var
  I: Integer;
begin
  if AList = nil then
    Exit;
  for I := 0 to AList.Count - 1 do
    Dispose(AList[I]);
  AList.Clear;
end;

procedure ClearRecordListOfList(AListOfList: TList);
var
  I, K: Integer;
  vList: TList;
begin
  if AListOfList = nil then
    Exit;
  for I := AListOfList.Count - 1 downto 0 do
    if AListOfList.List^[I] <> nil then
    begin
      vList := AListOfList.List^[I];
      for K := vList.Count - 1 downto 0 do
        if vList.List^[K] <> nil then
          Dispose(vList.List^[K]);
      vList.Free;
    end;
  AListOfList.Clear;
end;

procedure ClearListWithNilCheck(List: TList);
var
  I: Integer;
begin
  if List = nil then
    Exit;
  for I := 0 to List.Count - 1 do
    if List[I] <> nil then
      TObject(List[I]).Free;
  List.Clear;
end;

procedure DisposeDeleteFromList(AList: TList; const AIndex: Integer);
begin
  Dispose(AList.List^[AIndex]);
  AList.Delete(AIndex);
end;

procedure FreeList(var AList: TList);
begin
  ClearList(AList);
  if AList <> nil then
    AList.Free;
  AList := nil;
end;

procedure FreeRecordList(var AList: TList);
begin
  ClearRecordList(AList);
  if AList <> nil then
    AList.Free;
  AList := nil;
end;

procedure FreeRecordListOfList(var AListOfList: TList);
begin
  if AListOfList = nil then Exit;
  ClearRecordListOfList(AListOfList);
  if AListOfList <> nil then
    AListOfList.Free;
  AListOfList := nil;
end;

function FindAutoCADSHXPaths(APaths: TStringList): Boolean;
const
  ACADRegPath = 'Software\Autodesk\AutoCAD';
var
  S, vRegPath, vDir: string;
  vStrLst: array[0..3] of TStringList;
  I, J, K, vPos: Integer;
  function GetKeyNames(ANameLst: TStrings; const AValName: string;
    var AValue: string): Boolean;
  var
    vReg: TRegistry;
  begin
    Result := False;
    ANameLst.Clear;
    vReg := TRegistry.Create;
    try
      vReg.RootKey := HKEY_CURRENT_USER;
      if vReg.OpenKey(vRegPath,False) then
      begin
        Result := True;
        vReg.GetKeyNames(ANameLst);
        if (AValName <> '') and vReg.ValueExists(AValName) then
          AValue := vReg.ReadString(AValName)
        else
          AValue := '';
      end;
    finally
      vReg.Free;
    end;
  end;
  function IsSHXInFolder(const AFolder: string): Boolean;
  var
    vSr: TSearchRec;
    S: string;
    vLen: Integer;
  begin
    S := AFolder;
    vLen := Length(S);
    if vLen > 0 then
      if S[vLen] <> '\' then S := S + '\';
    Result := FindFirst(S + '*.shx', faAnyFile, vSr) = 0;
    FindClose(vSr);
  end;

begin
  Result := False;
  if not Assigned(APaths) then Exit;
  for I := 0 to 3 do
    vStrLst[I] := TStringList.Create;
  try
    vRegPath := ACADRegPath;
    GetKeyNames(vStrLst[0], '', S);
    for I := 0 to vStrLst[0].Count - 1 do
    begin
      vRegPath := ACADRegPath + '\' + vStrLst[0][I];
      GetKeyNames(vStrLst[1], '', S);
      for J := 0 to vStrLst[1].Count - 1 do
      begin
        vRegPath := vRegPath + '\' + vStrLst[1][J] + '\Profiles';
        GetKeyNames(vStrLst[2], '', S);
        for K := 0 to vStrLst[2].Count - 1 do
        begin
          vRegPath := vRegPath + '\' + vStrLst[2][K] + '\General';
          GetKeyNames(vStrLst[3], 'ACAD', S);
          while S <> '' do
          begin
            vPos := AnsiPos(';', S);
            if vPos = 0 then Break;
            vDir := Copy(S, 1, vPos - 1);
            if IsSHXInFolder(vDir) then APaths.Add(vDir);
            Delete(S, 1, vPos);
          end;
        end;
      end;
    end;
  finally
    for I := 0 to 3 do
      vStrLst[I].Free;
  end;
  Result := APaths.Count > 0;
end;

function FindDWGTrueViewSHXPaths(APaths: TStringList): Boolean;
const
  DWGTrueViewPath = 'Software\Autodesk\DWG TrueView';
  sRegAppDataSupportValueName = 'RoamableRootFolder';
  sLocation = 'Location';
  sSupport = 'Support';
  sFonts = 'Fonts';
var
  I, J: Integer;
  vReg: TRegistryIniFile;
  vSections: array[0 .. 1] of TStringList;
  S, vPath: string;

  function CorrectPath(const APath: string): string;
  var
    Len: Integer;
  begin
    Result := APath;
    Len := Length(Result);
    if Len > 0 then
      if Result[Len] <> '\' then Result := Result + '\';
  end;

  function IsSHXInFolder(const AFolder: string): Boolean;
  var
    vSr: TSearchRec;
  begin
    Result := FindFirst(CorrectPath(AFolder) + '*.shx', faAnyFile, vSr) = 0;
    SysUtils.FindClose(vSr);
  end;

{$IFNDEF SGDEL_2005}
  procedure ReadSectionValues(ARegIniFile: TRegIniFile; const Section: string; Strings: TStrings);
  var
    KeyList: TStringList;
    I: Integer;
  begin
    KeyList := TStringList.Create;
    try
      ARegIniFile.ReadSection(Section, KeyList);
      Strings.BeginUpdate;
      try
        for I := 0 to KeyList.Count - 1 do
          Strings.Values[KeyList[I]] := ARegIniFile.ReadString(Section, KeyList[I], '');
      finally
        Strings.EndUpdate;
      end;
    finally
      KeyList.Free;
    end;
  end;
{$ENDIF}

begin
  Result := False;
  if APaths <> nil then
  begin
    vReg := TRegistryIniFile.Create('');
    try
      for I := Low(vSections) to High(vSections) do
        vSections[I] := TStringList.Create;
      try
{$IFDEF SGDEL_2005}
        vReg.ReadSections(DWGTrueViewPath, vSections[0]);
{$ELSE}
        ReadSectionValues(vReg.RegIniFile, DWGTrueViewPath, vSections[0]);
{$ENDIF}
        for I := 0 to vSections[0].Count - 1 do
        begin
{$IFDEF SGDEL_2005}
          vReg.ReadSections(DWGTrueViewPath + '\' + vSections[0][I], vSections[1]);
{$ELSE}
          ReadSectionValues(vReg.RegIniFile, DWGTrueViewPath + '\' + vSections[0][I], vSections[1]);
{$ENDIF}
          J := vSections[1].Count;
          while (J > 0) and (vSections[1].Count > 0) do
          begin
            if Pos('DWGVIEWR', vSections[1][J-1]) = 1 then
              Dec(J)
            else vSections[1].Delete(J-1);
          end;
          for J := 0 to vSections[1].Count - 1 do
          begin
            S := DWGTrueViewPath + '\' + vSections[0][I] + '\' + vSections[1][J];
            vPath := vReg.ReadString(S, sRegAppDataSupportValueName, '');
            if vPath <> '' then
            begin
              vPath := CorrectPath(vPath) + sSupport;
              if IsSHXInFolder(vPath) and (APaths.IndexOf(vPath) = -1) then
                APaths.Add(vPath);
            end;
            vReg.RegIniFile.RootKey := HKEY_LOCAL_MACHINE;
            try
              vPath := vReg.ReadString(S, sLocation, '');
              if vPath <> '' then
              begin
                vPath := CorrectPath(vPath) + sFonts;
                if IsSHXInFolder(vPath) and (APaths.IndexOf(vPath) = -1) then
                  APaths.Add(vPath);
              end;
            finally
              vReg.RegIniFile.RootKey := HKEY_CURRENT_USER;
            end;
          end;
        end;
        Result := APaths.Count > 0;
      finally
        for I := Low(vSections) to High(vSections) do
          vSections[I].Free;
      end;
    finally
      vReg.Free;
    end;
  end;
end;

function FindSHXPaths(const APaths: TStringList): Boolean;
begin
  Result := False;
  FindAutoCADSHXPaths(APaths);
  if FindDWGTrueViewSHXPaths(APaths) then
    Result := True;
end;

procedure SetSHXSearchPaths(const APaths: TStringList);
var
  I: Integer;
  S: string;
  Len: Integer;
begin
  S := AnsiLowerCase(sSHXSearchPaths);
  Len := Length(S);
  if (Len > 0) and (S[Len] <> ';') then
    S := S + ';';
  for I := 0 to APaths.Count - 1 do
    if Pos(AnsiLowerCase(APaths[I]) + ';', S) <= 0 then
      sSHXSearchPaths := sSHXSearchPaths + APaths[I] + ';';
end;

function Min(const A, B: Double): Double;
begin
  if A < B then
    Result := A
  else
    Result := B;
end;

function Max(const A, B: Double): Double;
begin
  if A > B then
    Result := A
  else
    Result := B;
end;

function MinI(const A, B: Integer): Integer;
begin
  if A < B then
    Result := A
  else
    Result := B;
end;

function MaxI(const A, B: Integer): Integer;
begin
  if A > B then
    Result := A
  else
    Result := B;
end;

function GetIntersectingPoint(const Line1, Line2: TsgLine; var IntersectionMode: TIntersectionMode): TFPoint;
var
  K1, K2, B1, B2: Double;
begin
  Result := cnstFPointZero;
  IntersectionMode := imPoint;
  if IsEqual(Line1.Point2.X, Line1.Point1.X) then
  begin
    Result.X := Line1.Point2.X;
    if not IsEqual(Line2.Point2.X, Line2.Point1.X) then
    begin
      K2 := (Line2.Point2.Y - Line2.Point1.Y) / (Line2.Point2.X - Line2.Point1.X);
      B2 := Line2.Point1.Y - Line2.Point1.X * K2;
      Result.Y := B2 + Result.X * K2;
    end
    else
      if IsEqual(Line1.Point1.X, Line2.Point1.X) then
        IntersectionMode := imLine
      else
        IntersectionMode := imNone;
  end
  else
  if IsEqual(Line2.Point2.X, Line2.Point1.X) then
  begin
    Result.X := Line2.Point1.X;
    if not IsEqual(Line1.Point2.X, Line1.Point1.X) then
    begin
      K1 := (Line1.Point2.Y - Line1.Point1.Y) / (Line1.Point2.X - Line1.Point1.X);
      B1 := Line1.Point1.Y - Line1.Point1.X * K1;
      Result.Y := B1 + Result.X * K1
    end
    else
      if IsEqual(Line1.Point1.X, Line2.Point1.X) then
        IntersectionMode := imLine
      else
        IntersectionMode := imNone;
  end
  else
  begin
    K2 := (Line2.Point2.Y - Line2.Point1.Y) / (Line2.Point2.X - Line2.Point1.X);
    K1 := (Line1.Point2.Y - Line1.Point1.Y) / (Line1.Point2.X - Line1.Point1.X);
    B1 := Line1.Point1.Y - Line1.Point1.X * K1;
    B2 := Line2.Point1.Y - Line2.Point1.X * K2;
    if not IsEqual(K1, K2) then
    begin
      Result.X := (B2 - B1) / (K1 - K2);
      Result.Y := K1 * Result.X + B1;
    end
    else
      if IsEqual(B1, B2) then
        IntersectionMode := imLine
      else
        IntersectionMode := imNone;
  end;
end;

function GetIntresectingRectAndLine(const ARect: TFRect; const ALine: TsgLine; var IntersectionMode: TIntersectionMode): TsgLine;
var
  vIntersectPt: array[0..3] of TFPoint;
  vRectLine: TsgLine;
  vRect: TFRect;
  I, J: Integer;
  Temp: TFPoint;
  vIM: TIntersectionMode;
  A: TsgFloat;
begin
  vRect := ARect;
  if ARect.Top < ARect.Bottom then
  begin
    vRect.Top := ARect.Bottom;
    vRect.Bottom := ARect.Top;
  end;
  //Left line
  vRectLine.Point1 := vRect.TopLeft;
  vRectLine.Point2.X := vRect.Left;
  vRectLine.Point2.Y := vRect.Bottom;
  vIntersectPt[0] := GetIntersectingPoint(vRectLine, ALine, vIM);
  if (vIM <> imPoint)or
     (vRectLine.Point1.Y < vIntersectPt[0].Y)or(vIntersectPt[0].Y < vRectLine.Point2.Y) then
    vIntersectPt[0].X := MaxTsgFloat;
  //Bottom line
  vRectLine.Point1 := vRectLine.Point2;
  vRectLine.Point2 := vRect.BottomRight;
  vIntersectPt[1] := GetIntersectingPoint(vRectLine, ALine, vIM);
  if (vIM <> imPoint)or
     (vRectLine.Point1.X > vIntersectPt[1].X)or(vIntersectPt[1].X > vRectLine.Point2.X) then
    vIntersectPt[1].X := MaxTsgFloat;
  //Right line
  vRectLine.Point1 := vRectLine.Point2;
  vRectLine.Point2.X := vRect.Right;
  vRectLine.Point2.Y := vRect.Top;
  vIntersectPt[2] := GetIntersectingPoint(vRectLine, ALine, vIM);
  if (vIM <> imPoint)or
     (vRectLine.Point1.Y > vIntersectPt[2].Y)or(vIntersectPt[2].Y > vRectLine.Point2.Y) then
    vIntersectPt[2].X := MaxTsgFloat;
  //Top line
  vRectLine.Point1 := vRectLine.Point2;
  vRectLine.Point2 := vRect.TopLeft;
  vIntersectPt[3] := GetIntersectingPoint(vRectLine, ALine, vIM);
  if (vIM <> imPoint)or
     (vRectLine.Point1.X < vIntersectPt[3].X)or(vIntersectPt[3].X < vRectLine.Point2.X) then
    vIntersectPt[3].X := MaxTsgFloat;
  for I := 0 to 2 do
    for J := 0 to 2 - I do
      if vIntersectPt[J].X > vIntersectPt[J + 1].X then
      begin
        Temp := vIntersectPt[J];
        vIntersectPt[J] := vIntersectPt[J + 1];
        vIntersectPt[J + 1] := Temp;
      end;
  Result.Point1 := vIntersectPt[0];
  I := 1;
  while (Abs(vIntersectPt[0].X - vIntersectPt[I].X) < FAccuracy)and(Abs(vIntersectPt[0].Y - vIntersectPt[I].Y) < FAccuracy)and(I < 3) do
    Inc(I);
  Result.Point2 := vIntersectPt[I];
  A := MaxTsgFloat;
  if (not CompareMem(@Result.Point1.X, @A, SizeOf(Result.Point1.X)))and(not CompareMem(@Result.Point2.X, @A, SizeOf(Result.Point1.X))) then
    IntersectionMode := imLine
  else
    if (not CompareMem(@Result.Point1.X, @A, SizeOf(Result.Point1.X)))and(CompareMem(@Result.Point1.X, @A, SizeOf(Result.Point1.X))) then
      IntersectionMode := imPoint
    else
      IntersectionMode := imNone;
end;

function GetNameByEntTypeEx(const AType: Integer): string;
begin
  case AType of
    cnstDimConstruction:  Result := sEntNamesEx[0];
    cnstConstruction:     Result := sEntNamesEx[1];
    cnstComplex:          Result := sEntNamesEx[2];
    cnstElement:          Result := sEntNamesEx[3];
    cnstComplexBroad:     Result := sEntNamesEx[4];
    cnstComplexLinear:    Result := sEntNamesEx[5];
    cnstElementBroad:     Result := sEntNamesEx[6];
    cnstElementLinear:    Result := sEntNamesEx[7];
    cnstElementCarved:    Result := sEntNamesEx[8];
    cnstElementModifier:  Result := sEntNamesEx[14];
    cnstArea:             Result := sEntNamesEx[9];
    cnstComplexArea:      Result := sEntNamesEx[10];
    cnstLabel:            Result := sEntNamesEx[11];
    cnstDimLabel:         Result := sEntNamesEx[12];
    cnstBlockPattern:     Result := sEntNamesEx[13];
  else
    Result := sEntNamesEx[-1];
  end;
end;

function MaxTsgFloat: Extended;
begin
  case SizeOf(TsgFloat) of
    4: Result := MaxSingle;
    8: Result := MaxDouble;
    10: Result := MaxExtended;
  else
    Result := MaxSingle;
  end;
end;

function DistanceF(APoint1, APoint2: TFPoint): Double;
begin
  Result := Sqr(APoint2.X - APoint1.X) + Sqr(APoint2.Y - APoint1.Y) + Sqr(APoint2.Z - APoint1.Z);
  if Result > fDoubleResolution then
    Result := Sqrt(Result)
  else
    Result := 0;
end;

function DistanceI(APoint1, APoint2: TPoint): Double;
var
  P1X, P2X, P1Y, P2Y: Double;
begin
  P1X := APoint1.X;
  P2X := APoint2.X;
  P1Y := APoint1.Y;
  P2Y := APoint2.Y;
  Result := Sqrt(Sqr(P2X - P1X) + Sqr(P2Y - P1Y));
end;

procedure SwapInts(var A,B);
asm
	MOV	ECX,[EAX]
	XCHG	ECX,[EDX]
	MOV	[EAX],ECX
end;

procedure SwapFPoints(var A,B: TFPoint);
var
  vTmp: TFPoint;
begin
  vTmp := B;
  B := A;
  A := vTmp;
end;

function IsBadRect(ARect: TFRect): Boolean;
begin
  Result := True;
  if (ARect.Right < ARect.Left) or (ARect.Top < ARect.Bottom)
    or (ARect.Z2 < ARect.Z1) then
      Exit;
  Result := False;
end;

function IsEqual(const AVal1, AVal2: TsgFloat): Boolean;
begin
  Result := Abs(AVal1 - AVal2) < fAccuracy;
end;

function IsEqualPoints(const Point1, Point2: TPoint): Boolean;
begin
  Result := (Point1.X = Point2.X) and (Point1.Y = Point2.Y);
end;

function IsEqualFPoints(const Point1, Point2: TFPoint): Boolean;
begin
  Result := (Abs(Point1.X - Point2.X) < fAccuracy) and (Abs(Point1.Y - Point2.Y) < fAccuracy) and
    (Abs(Point1.Z - Point2.Z) < fAccuracy);
end;

function IsEqualFPoints2D(const Point1, Point2: TFPoint): Boolean;
begin
  Result := (Abs(Point1.X - Point2.X) < fAccuracy) and (Abs(Point1.Y - Point2.Y) < fAccuracy);
end;

function IsEqualF2DPoints(const Point1, Point2: TF2DPoint): Boolean;
begin
  Result := (Abs(Point1.X - Point2.X) < fAccuracy) and (Abs(Point1.Y - Point2.Y) < fAccuracy);
end;

{  PointClassify

   p0, p1 - line (segment from p0 to p1)

   Classifies a point concerning a line. }
function PointClassify(p, p0, p1: TFPoint): TsgPointClassify;
var
  a, b: TFPoint;
  sa, vAccuracy, vSegmentLength: Double;

  function VectLength(AFPoint: TFPoint): Extended;
  begin
    try
      Result := Sqrt(Abs(AFPoint.X*AFPoint.X) + Abs(AFPoint.Y*AFPoint.Y));
    except
      Result := 0.0;
    end;
  end;
  
begin
  a := MakeFPoint(p1.X - p0.X, p1.Y - p0.Y, 0);
  b := MakeFPoint(p.X - p0.X, p.Y - p0.Y, 0);
  vSegmentLength := VectLength(a);
  vAccuracy := GetAccuracy(vSegmentLength);
  sa := a.X * b.Y - b.X * a.Y;
  Result := pcBETWEEN;
  if sa > vAccuracy then
    Result := pcLEFT
  else
    if sa < -vAccuracy then
      Result := pcRIGHT
    else
      if (a.X * b.X < 0.0) or (a.Y * b.Y < 0.0) then
        Result := pcBEHIND
      else
        if vSegmentLength < VectLength(b) then
          Result := pcBEYOND
        else
          if (p0.X = p.X) and (p0.Y = p.Y) then
            Result := pcORIGIN
          else
            if (p1.X = p.X) and (p1.Y = p.Y) then
              Result := pcDESTINATION;
end;

{$IFNDEF SGDEL_6}
function WideUpperCase(const S: WideString): WideString;
var
  Len: Integer;
begin
  Len := Length(S);
  SetString(Result, PWideChar(S), Len);
  if Len > 0 then CharUpperBuffW(Pointer(Result), Len);
end;
{$ENDIF}

function CreateParamData: PsgParamData;
begin
  New(Result);
  FillChar(Result^, SizeOf(Result^), 0);
end;

{$IFDEF SGDEL_7}
{$IFDEF SG_USE_INDY}
function GetDataFromHttp(const AHost: string; AStream: TStream; TimeOut: Integer;
  var AFileName: string; const AProxyInfo: TsgHTTPProxyInfo;
  AUseProxy: Boolean = False): Boolean;
const
  cntSlashes = '://';
  cntSlash = '/';
var
  vHost: string;
  IdHTTP: TIdHTTP;
  IdAntiFreeze: TIdAntiFreeze;
  vPos: Integer;

  procedure FreeAll;
  begin
    FreeAndNil(IdHTTP);
    FreeAndNil(IdAntiFreeze);
  end;

begin
  Result := False;

  AStream.Size := 0;
  AStream.Position := 0;

  vHost := AHost;
  if Copy(UpperCase(vHost), 1, 4) <> 'HTTP' then vHost := 'http' + cntSlashes + vHost;
  IdHTTP := TIdHTTP.Create(nil);
  IdAntiFreeze := TIdAntiFreeze.Create(nil);
  IdAntiFreeze.Active := True;
  try
   //IdHTTP.OnStatus := AOnStatus;
   IdHTTP.ReadTimeout := TimeOut;
   if AUseProxy then
    begin
      IdHTTP.ProxyParams.ProxyServer := AProxyInfo.ProxyHost;
      IdHTTP.ProxyParams.ProxyPort := AProxyInfo.ProxyPort;
      if AProxyInfo.ProxyNeedPass then
      begin
        IdHTTP.ProxyParams.ProxyUsername := AProxyInfo.ProxyUser;
        IdHTTP.ProxyParams.ProxyPassword := AProxyInfo.ProxyPass;
      end;
    end;
    IdHTTP.HandleRedirects := True;
    //IdHTTP.RedirectMaximum := 10;
    try
      IdHTTP.Get(vHost, AStream)
    except
      FreeAll;
      Exit;
    end;
    AStream.Position := 0;
    AFileName := AHost;
    vPos := Pos(cntSlashes, AFileName);
    if vPos > 0 then
      AFileName := Copy(AFileName, vPos + Length(cntSlashes) + 1, MaxInt);
    repeat
      vPos := Pos(cntSlash, AFileName);
      if vPos > 0 then
        AFileName[vPos] := '\';
    until vPos = 0;
    AFileName := ExtractFileName(AFileName);
    Result := True;
  finally
    FreeAll;
  end;
end;
{$ENDIF}
{$ENDIF}

function GetBTITypeByEntTypeEx(const ATypeEx: Integer): TbtiEntity;
begin
  case ATypeEx of
    cnstDimConstruction: Result := btiDimConstruction;
    cnstConstruction:    Result := btiConstruction;
    cnstComplex:         Result := btiComplex;
    cnstElement:         Result := btiElement;
    cnstComplexBroad:    Result := btiComplexBroad;
    cnstComplexLinear:   Result := btiComplexLinear;
    cnstElementBroad:    Result := btiElementBroad;
    cnstElementLinear:   Result := btiElementLinear;
    cnstElementCarved:   Result := btiElementCarved;
    cnstElementModifier: Result := btiElementModifier;
    cnstArea:            Result := btiArea;
    cnstComplexArea:     Result := btiComplexArea;
    cnstLabel:           Result := btiLabel;
    cnstDimLabel:        Result := btiDimLabel;
    cnstBlockPattern:    Result := btiBlockPattern;
  else
    Result := btiUndefined;
  end;
end;

{$IFNDEF SGDEL_2009}
function AnsiStrAlloc(Size: Cardinal): PAnsiChar;
begin
  Result := StrAlloc(Size);
end;

function CharInSet(C: AnsiChar; const CharSet: TSysCharSet): Boolean;
begin
  Result := C in CharSet;
end;

function CharInSet(C: WideChar; const CharSet: TSysCharSet): Boolean;
begin
  Result := (C < #$0100) and (AnsiChar(C) in CharSet);
end;
{$ENDIF}

procedure ClearParamData(const AParam: PsgParamData);
begin
  if AParam <> nil then
  begin
    if (AParam^.PType = ptList) and (AParam^.DataLst <> nil) then
      AParam^.DataLst.Free;
    FillChar(AParam^, SizeOf(AParam^), 0);
  end;
end;

procedure DisposeParamData(var AParam: PsgParamData);
begin
  ClearParamData(AParam);
  Dispose(AParam)
end;

function GetArrowTypeByName(AName: string; const DefValue: Byte): Byte;
const
  cnstBlockPrefix = '_';
var
  I: Integer;
begin
  Result := DefValue;
  if Length(AName) > 0 then
  begin
    AName := AnsiUpperCase(AName);
    if AName[1] <> cnstBlockPrefix then
      AName := cnstBlockPrefix + AName;
    for I := Low(sgDimensionArrowTypeNames) to High(sgDimensionArrowTypeNames) do
      if AName = sgDimensionArrowTypeNames[I] then
      begin
        Result := I;
        Break;
      end;
  end;    
end;

function StringHexToIntDef(const AStr: string; ADef: Integer): UInt64;
var
  E: Integer;
begin
  Val('$'+ AStr, Result, E);
  if E <> 0 then Result := ADef;
end;

function GetMultibyteSymbol(const ALeft, ARight: Byte; const ANumber: Integer): WideChar;
var
  vCodePage: Integer;
  vWideStr: WideString;
begin
  case ANumber of
    1: vCodePage := 932;
    2: vCodePage := 950;
    3: vCodePage := 949;
    //4: vCodePage := 936;// Undefined - please correct in future versions
    5: vCodePage := 936;
  else
    vCodePage := CP_ACP;// current system Windows ANSI code page
  end;
  vWideStr := ConvertToWideString(AnsiChar(ALeft) + AnsiChar(ARight), vCodePage);
  if vWideStr <> '' then
    Result := vWideStr[1]
  else
    Result := WideChar(0);
end;

function ConvertToWideString(const AText: AnsiString; const ACodePage: Integer): WideString;
var
  vLen: Integer;
begin
  Result := '';
  vLen := MultiByteToWideChar(ACodePage, 0, PAnsiChar(AText), Length(AText), nil, 0);
  if vLen <> 0 then
  begin
    SetLength(Result, vLen);
    if MultiByteToWideChar(ACodePage, 0, PAnsiChar(AText), Length(AText),
      PWideChar(Result), vLen) = 0 then
      Result := '';
  end;
end;

function ConvertToAnsiString(const AText: WideString; const ACodePage: Integer): sgRawByteString;
var
  N: Integer;
begin
  Result := '';
  N := WideCharToMultiByte(ACodePage, 0, PWideChar(AText), Length(AText), nil, 0, nil, nil);
  if N > 0 then
  begin
    SetLength(Result, N);
    WideCharToMultiByte(ACodePage, 0, PWideChar(AText), Length(AText), PAnsiChar(Result), N, nil, nil);
  end;
end;

function StringToACADPresentation(const AString: sgUnicodeStr; const ACodePage: Integer): sgRawByteString;
const
  Mask = $400; // WC_NO_BEST_FIT_CHARS
var
  I, vOutLen: Integer;
  vInChar: sgUnicodeStr;
  vOutChar: sgRawByteString; // type "string" for 2-byte characters (double-byte character set)
  vNotConvert: Boolean;
begin
  Result := '';
  if AString = '' then
    Exit;
  for I := 1 to Length(AString) do
  begin
    vInChar := AString[I] + sgUnicodeStr(#0);
    vOutChar := '';
    if Integer(vInChar[1]) <= 127 then // don't need converting
      vOutChar := AnsiChar(vInChar[1])
    else
    begin
      vOutLen := WideCharToMultiByte(ACodePage, Mask, PWideChar(vInChar), 1,
        nil, 0, nil, @vNotConvert);
      if (vOutLen > 0) and not vNotConvert then
      begin
        SetLength(vOutChar, vOutLen);
        WideCharToMultiByte(ACodePage, Mask, PWideChar(vInChar), 1,
          PAnsiChar(vOutChar), vOutLen, nil, nil);
      end
      else
      begin
        vOutChar := '\U+' + sgRawByteString(IntToHex(Integer(vInChar[1]), 4));
      end;
    end;
    Result := Result + vOutChar;
  end;
{
  case FCADImage.Converter.CodePage of
    932: vNum := 1;
    936: vNum := 5;
    949: vNum := 3;
    950: vNum := 2;
  else
    Exit;
  end;
  vText := Result;
  Result := '';
  I := 1;
  vLen := Length(vText);
  while I <= vLen do
  begin
    if CharInSet(vText[I], ['!'..'~', ' ']) or (I+1 > vLen) then
    begin
      Result := Result + vText[I];
      Inc(I);
    end
    else
    begin
      Result := Result + '\M+'+ IntToStr(vNum) + IntToHex(Byte(vText[I]), 2) + IntToHex(Byte(vText[I+1]), 2);
      Inc(I, 2);
    end;
  end;
  (* Unicode
  // WCh: Integer;
  // vUnicodeText: WideString;
  vUnicodeText := ConvertToWideString(TsgDXFMText(ATextEntity).Text, TsgDXFConverterEx(FCADImage.Converter).CodePage);
  vLen := Length(vUnicodeText);
  while I <= vLen do
  begin
    WCh := Integer(vUnicodeText[I]);
    if (WCh shr 8 = 0) and (Char(vUnicodeText[I]) in ['!'..'~', ' ']) then
      Result := Result + vUnicodeText[I]
    else
      Result := Result + '\U+' + IntToHex(WCh shr 8, 2) + IntToHex(WCh and $00FF, 2);
    Inc(I);
  end; *)
  }
end;

function IsDigit(AChar: Char): Boolean;
begin
{$IFDEF SGDEL_2009}
  Result := TCharacter.IsDigit(AChar)
{$ELSE}
  Result := AChar in ['0'..'9'];
{$ENDIF}
end;

{$IFNDEF SGDEL_2009}
function IsDigit(AChar: WideChar): Boolean;
begin
{$IFDEF SGDEL_2009}
  Result := TCharacter.IsDigit(AChar)
{$ELSE}
  Result := AnsiChar(AChar) in ['0'..'9'];
{$ENDIF}
end;
{$ENDIF}

function GetNameByArrowType(const AType: Byte; const DefValue: string): string;
begin
  if AType <= High(sgDimensionArrowTypeNames) then
    Result := sgDimensionArrowTypeNames[AType]
  else
    Result := DefValue;
end;

function CmdSymReplaceU(const AText: sgUnicodeStr): sgUnicodeStr;
var
  vLeft, vRight: Byte;
begin
  Result := '';
  if Length(AText) < 4 then
    Exit;
  vLeft := StringHexToIntDef(Copy(AText, 1, 2), 0);
  vRight := StringHexToIntDef(Copy(AText, 3, 2), 0);
  Result := sgUnicodeChar((vLeft shl 8) or vRight);
end;

function CmdSymReplaceM(const AText: sgUnicodeStr): sgUnicodeStr;
var
  vLeft, vRight, vNumber: Byte;
begin
  Result := '';
  if Length(AText) < 5 then
    Exit;
  vLeft := StringHexToIntDef(Copy(AText, 2, 2), 0);
  vRight := StringHexToIntDef(Copy(AText, 4, 2), 0);
  vNumber := StringHexToIntDef(Copy(AText, 1, 1), 0);
  Result := GetMultibyteSymbol(vLeft, vRight, vNumber);
end;

//function CmdSymReplaceDPercent(const AText: sgUnicodeStr): sgUnicodeStr;
//var
//  vAnsi: AnsiString;
//  vCode: Integer;
//begin
//  vAnsi := '';
//  SetCodePage(RawByteString(vAnsi), AConverter.CodePage, False);
//  vCode := StrToIntDef(AText, -1);
//  if vCode = -1 then
//    Result := ''
//  else
//    Result := sgUnicodeStr(AnsiChar(vCode));
//end;

function ParseCommandSym(const AText, ACmd: sgUnicodeStr; var AOutText: sgUnicodeStr;
  ChrCntDef: Integer; AProc: TCmdSymReplaceProc): Boolean;

  function GetCharCnt(AIndex: Integer): Integer;
  begin
    Result := 0;
    if ChrCntDef > 0 then
      Result := Math.Min(ChrCntDef, Length(AOutText) - AIndex + 1)
    else
      while (Length(AOutText) >= AIndex + Result) and
        IsDigit(AOutText[AIndex + Result]) do
        Inc(Result);
  end;

var
  S: sgUnicodeStr;
  I, ChrCnt: Integer;
begin
  Result := False;
  AOutText := AText;
  I := Pos(ACmd, AOutText);
  while I > 0 do
  begin
    Delete(AOutText, I, Length(ACmd));
    ChrCnt := GetCharCnt(I);
    if ChrCnt > 0 then
    begin
      S := Copy(AOutText, I, ChrCnt);
      Delete(AOutText, I, ChrCnt);
      Insert(AProc(S), AOutText, I);
      Result := True;
    end;
    I := Pos(ACmd, AOutText);
  end;
end;

function ParseUnicode(AStr: sgUnicodeStr; AModes: TParseUnicodeModes): sgUnicodeStr;
begin
  Result := AStr;
  if puU in AModes then
    ParseCommandSym(Result, cnstTypeU, Result, 4, @CmdSymReplaceU);
  if puM in AModes then
    ParseCommandSym(Result, cnstTypeM, Result, 5, @CmdSymReplaceM);
//  if puDP in AModes then
//    ParseCommandSym(AStr, cnstTypeDP, AStr, -1, @CmdSymReplaceDPercent);
end;

{$IFDEF SGDEL_2006}
{ TsgUInt64 }

class operator TsgUInt64.Implicit(I: Integer): TsgUInt64;
begin
  Result.Lo := I;
  Result.Hi := 0;
end;

class operator TsgUInt64.Implicit(I: Int64): TsgUInt64;
begin
  Result.All := I;
end;

class operator TsgUInt64.Add(const A, B: TsgUInt64): TsgUInt64;
begin
  Result.All := A.All + B.All;
end;

class operator TsgUInt64.BitwiseOr(const A, B: TsgUInt64): TsgUInt64;
begin
  Result.All := A.All or B.All;
end;

class operator TsgUInt64.Equal(const A, B: TsgUInt64): Boolean;
begin
  Result := (A.FHi = B.FHi) and (A.FLo = B.FLo);
end;

function TsgUInt64.GetAll: Int64;
begin
  Result := Int64(FHi) shl 32 + FLo;
end;

function TsgUInt64.GetHi: Cardinal;
begin
  Result := FHi;
end;

function TsgUInt64.GetLo: Cardinal;
begin
  Result := FLo;
end;

class operator TsgUInt64.GreaterThan(const A, B: TsgUInt64): Boolean;
begin
  Result := A.FHi > B.FHi;
  if not Result and (A.FHi = B.FHi) then Result := A.FLo > B.FLo;
end;

class operator TsgUInt64.GreaterThanOrEqual(const A, B: TsgUInt64): Boolean;
begin
  Result := not (A < B);
end;

class operator TsgUInt64.Implicit(const A: TsgUInt64): Integer;
begin
  Result := A.FLo;
end;

class operator TsgUInt64.Implicit(const A: TsgUInt64): Int64;
begin
  Result := A.GetAll;
end;


class operator TsgUInt64.LessThan(const A, B: TsgUInt64): Boolean;
begin
  Result := A.FHi < B.FHi;
  if not Result and (A.FHi = B.FHi) then Result := A.FLo < B.FLo;
end;

class operator TsgUInt64.LessThanOrEqual(const A, B: TsgUInt64): Boolean;
begin
  Result := not (A > B);
end;

class operator TsgUInt64.Negative(const A: TsgUInt64): TsgUInt64;
begin
  Result.All := -A.All;
end;

class operator TsgUInt64.NotEqual(const A, B: TsgUInt64): Boolean;
begin
  Result := (A.FHi <> B.FHi) or (A.FLo <> B.FLo);
end;

procedure TsgUInt64.SetAll(const Value: Int64);
begin
  FLo := Value;
  FHi := Int64(Value) shr 32;
end;

procedure TsgUInt64.SetHi(const Value: Cardinal);
begin
  FHi := Value;
end;

procedure TsgUInt64.SetLo(const Value: Cardinal);
begin
  FLo := Value;
end;

class operator TsgUInt64.LeftShift(const A: TsgUInt64; B: Integer): TsgUInt64;
begin
  Result.All := A.All shl B;
end;

class operator TsgUInt64.RightShift(const A: TsgUInt64; B: Integer): TsgUInt64;
begin
  Result.All := A.All shr B;
end;

class operator TsgUInt64.Subtract(const A, B: TsgUInt64): TsgUInt64;
begin
  Result.All := A.All - B.All;
end;
{$ENDIF}

end.
